(function(root) {
define("jquery-chosen", ["jquery"], function() {
  return (function() {
/*!
Chosen, a Select Box Enhancer for jQuery and Prototype
by Patrick Filler for Harvest, http://getharvest.com

Version 1.5.1
Full source at https://github.com/harvesthq/chosen
Copyright (c) 2011-2016 Harvest http://getharvest.com

MIT License, https://github.com/harvesthq/chosen/blob/master/LICENSE.md
This file is generated by `grunt build`, do not edit it by hand.
*/

(function() {
  var $, AbstractChosen, Chosen, SelectParser, _ref,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  SelectParser = (function() {
    function SelectParser() {
      this.options_index = 0;
      this.parsed = [];
    }

    SelectParser.prototype.add_node = function(child) {
      if (child.nodeName.toUpperCase() === "OPTGROUP") {
        return this.add_group(child);
      } else {
        return this.add_option(child);
      }
    };

    SelectParser.prototype.add_group = function(group) {
      var group_position, option, _i, _len, _ref, _results;
      group_position = this.parsed.length;
      this.parsed.push({
        array_index: group_position,
        group: true,
        label: this.escapeExpression(group.label),
        title: group.title ? group.title : void 0,
        children: 0,
        disabled: group.disabled,
        classes: group.className
      });
      _ref = group.childNodes;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        _results.push(this.add_option(option, group_position, group.disabled));
      }
      return _results;
    };

    SelectParser.prototype.add_option = function(option, group_position, group_disabled) {
      if (option.nodeName.toUpperCase() === "OPTION") {
        if (option.text !== "") {
          if (group_position != null) {
            this.parsed[group_position].children += 1;
          }
          this.parsed.push({
            array_index: this.parsed.length,
            options_index: this.options_index,
            value: option.value,
            text: option.text,
            html: option.innerHTML,
            title: option.title ? option.title : void 0,
            selected: option.selected,
            disabled: group_disabled === true ? group_disabled : option.disabled,
            group_array_index: group_position,
            group_label: group_position != null ? this.parsed[group_position].label : null,
            classes: option.className,
            style: option.style.cssText
          });
        } else {
          this.parsed.push({
            array_index: this.parsed.length,
            options_index: this.options_index,
            empty: true
          });
        }
        return this.options_index += 1;
      }
    };

    SelectParser.prototype.escapeExpression = function(text) {
      var map, unsafe_chars;
      if ((text == null) || text === false) {
        return "";
      }
      if (!/[\&\<\>\"\'\`]/.test(text)) {
        return text;
      }
      map = {
        "<": "&lt;",
        ">": "&gt;",
        '"': "&quot;",
        "'": "&#x27;",
        "`": "&#x60;"
      };
      unsafe_chars = /&(?!\w+;)|[\<\>\"\'\`]/g;
      return text.replace(unsafe_chars, function(chr) {
        return map[chr] || "&amp;";
      });
    };

    return SelectParser;

  })();

  SelectParser.select_to_array = function(select) {
    var child, parser, _i, _len, _ref;
    parser = new SelectParser();
    _ref = select.childNodes;
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      child = _ref[_i];
      parser.add_node(child);
    }
    return parser.parsed;
  };

  AbstractChosen = (function() {
    function AbstractChosen(form_field, options) {
      this.form_field = form_field;
      this.options = options != null ? options : {};
      if (!AbstractChosen.browser_is_supported()) {
        return;
      }
      this.is_multiple = this.form_field.multiple;
      this.set_default_text();
      this.set_default_values();
      this.setup();
      this.set_up_html();
      this.register_observers();
      this.on_ready();
    }

    AbstractChosen.prototype.set_default_values = function() {
      var _this = this;
      this.click_test_action = function(evt) {
        return _this.test_active_click(evt);
      };
      this.activate_action = function(evt) {
        return _this.activate_field(evt);
      };
      this.active_field = false;
      this.mouse_on_container = false;
      this.results_showing = false;
      this.result_highlighted = null;
      this.allow_single_deselect = (this.options.allow_single_deselect != null) && (this.form_field.options[0] != null) && this.form_field.options[0].text === "" ? this.options.allow_single_deselect : false;
      this.disable_search_threshold = this.options.disable_search_threshold || 0;
      this.disable_search = this.options.disable_search || false;
      this.enable_split_word_search = this.options.enable_split_word_search != null ? this.options.enable_split_word_search : true;
      this.group_search = this.options.group_search != null ? this.options.group_search : true;
      this.search_contains = this.options.search_contains || false;
      this.single_backstroke_delete = this.options.single_backstroke_delete != null ? this.options.single_backstroke_delete : true;
      this.max_selected_options = this.options.max_selected_options || Infinity;
      this.inherit_select_classes = this.options.inherit_select_classes || false;
      this.display_selected_options = this.options.display_selected_options != null ? this.options.display_selected_options : true;
      this.display_disabled_options = this.options.display_disabled_options != null ? this.options.display_disabled_options : true;
      this.include_group_label_in_selected = this.options.include_group_label_in_selected || false;
      return this.max_shown_results = this.options.max_shown_results || Number.POSITIVE_INFINITY;
    };

    AbstractChosen.prototype.set_default_text = function() {
      if (this.form_field.getAttribute("data-placeholder")) {
        this.default_text = this.form_field.getAttribute("data-placeholder");
      } else if (this.is_multiple) {
        this.default_text = this.options.placeholder_text_multiple || this.options.placeholder_text || AbstractChosen.default_multiple_text;
      } else {
        this.default_text = this.options.placeholder_text_single || this.options.placeholder_text || AbstractChosen.default_single_text;
      }
      return this.results_none_found = this.form_field.getAttribute("data-no_results_text") || this.options.no_results_text || AbstractChosen.default_no_result_text;
    };

    AbstractChosen.prototype.choice_label = function(item) {
      if (this.include_group_label_in_selected && (item.group_label != null)) {
        return "<b class='group-name'>" + item.group_label + "</b>" + item.html;
      } else {
        return item.html;
      }
    };

    AbstractChosen.prototype.mouse_enter = function() {
      return this.mouse_on_container = true;
    };

    AbstractChosen.prototype.mouse_leave = function() {
      return this.mouse_on_container = false;
    };

    AbstractChosen.prototype.input_focus = function(evt) {
      var _this = this;
      if (this.is_multiple) {
        if (!this.active_field) {
          return setTimeout((function() {
            return _this.container_mousedown();
          }), 50);
        }
      } else {
        if (!this.active_field) {
          return this.activate_field();
        }
      }
    };

    AbstractChosen.prototype.input_blur = function(evt) {
      var _this = this;
      if (!this.mouse_on_container) {
        this.active_field = false;
        return setTimeout((function() {
          return _this.blur_test();
        }), 100);
      }
    };

    AbstractChosen.prototype.results_option_build = function(options) {
      var content, data, data_content, shown_results, _i, _len, _ref;
      content = '';
      shown_results = 0;
      _ref = this.results_data;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        data = _ref[_i];
        data_content = '';
        if (data.group) {
          data_content = this.result_add_group(data);
        } else {
          data_content = this.result_add_option(data);
        }
        if (data_content !== '') {
          shown_results++;
          content += data_content;
        }
        if (options != null ? options.first : void 0) {
          if (data.selected && this.is_multiple) {
            this.choice_build(data);
          } else if (data.selected && !this.is_multiple) {
            this.single_set_selected_text(this.choice_label(data));
          }
        }
        if (shown_results >= this.max_shown_results) {
          break;
        }
      }
      return content;
    };

    AbstractChosen.prototype.result_add_option = function(option) {
      var classes, option_el;
      if (!option.search_match) {
        return '';
      }
      if (!this.include_option_in_results(option)) {
        return '';
      }
      classes = [];
      if (!option.disabled && !(option.selected && this.is_multiple)) {
        classes.push("active-result");
      }
      if (option.disabled && !(option.selected && this.is_multiple)) {
        classes.push("disabled-result");
      }
      if (option.selected) {
        classes.push("result-selected");
      }
      if (option.group_array_index != null) {
        classes.push("group-option");
      }
      if (option.classes !== "") {
        classes.push(option.classes);
      }
      option_el = document.createElement("li");
      option_el.className = classes.join(" ");
      option_el.style.cssText = option.style;
      option_el.setAttribute("data-option-array-index", option.array_index);
      option_el.innerHTML = option.search_text;
      if (option.title) {
        option_el.title = option.title;
      }
      return this.outerHTML(option_el);
    };

    AbstractChosen.prototype.result_add_group = function(group) {
      var classes, group_el;
      if (!(group.search_match || group.group_match)) {
        return '';
      }
      if (!(group.active_options > 0)) {
        return '';
      }
      classes = [];
      classes.push("group-result");
      if (group.classes) {
        classes.push(group.classes);
      }
      group_el = document.createElement("li");
      group_el.className = classes.join(" ");
      group_el.innerHTML = group.search_text;
      if (group.title) {
        group_el.title = group.title;
      }
      return this.outerHTML(group_el);
    };

    AbstractChosen.prototype.results_update_field = function() {
      this.set_default_text();
      if (!this.is_multiple) {
        this.results_reset_cleanup();
      }
      this.result_clear_highlight();
      this.results_build();
      if (this.results_showing) {
        return this.winnow_results();
      }
    };

    AbstractChosen.prototype.reset_single_select_options = function() {
      var result, _i, _len, _ref, _results;
      _ref = this.results_data;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        result = _ref[_i];
        if (result.selected) {
          _results.push(result.selected = false);
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    AbstractChosen.prototype.results_toggle = function() {
      if (this.results_showing) {
        return this.results_hide();
      } else {
        return this.results_show();
      }
    };

    AbstractChosen.prototype.results_search = function(evt) {
      if (this.results_showing) {
        return this.winnow_results();
      } else {
        return this.results_show();
      }
    };

    AbstractChosen.prototype.winnow_results = function() {
      var escapedSearchText, option, regex, results, results_group, searchText, startpos, text, zregex, _i, _len, _ref;
      this.no_results_clear();
      results = 0;
      searchText = this.get_search_text();
      escapedSearchText = searchText.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
      zregex = new RegExp(escapedSearchText, 'i');
      regex = this.get_search_regex(escapedSearchText);
      _ref = this.results_data;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        option.search_match = false;
        results_group = null;
        if (this.include_option_in_results(option)) {
          if (option.group) {
            option.group_match = false;
            option.active_options = 0;
          }
          if ((option.group_array_index != null) && this.results_data[option.group_array_index]) {
            results_group = this.results_data[option.group_array_index];
            if (results_group.active_options === 0 && results_group.search_match) {
              results += 1;
            }
            results_group.active_options += 1;
          }
          option.search_text = option.group ? option.label : option.html;
          if (!(option.group && !this.group_search)) {
            option.search_match = this.search_string_match(option.search_text, regex);
            if (option.search_match && !option.group) {
              results += 1;
            }
            if (option.search_match) {
              if (searchText.length) {
                startpos = option.search_text.search(zregex);
                text = option.search_text.substr(0, startpos + searchText.length) + '</em>' + option.search_text.substr(startpos + searchText.length);
                option.search_text = text.substr(0, startpos) + '<em>' + text.substr(startpos);
              }
              if (results_group != null) {
                results_group.group_match = true;
              }
            } else if ((option.group_array_index != null) && this.results_data[option.group_array_index].search_match) {
              option.search_match = true;
            }
          }
        }
      }
      this.result_clear_highlight();
      if (results < 1 && searchText.length) {
        this.update_results_content("");
        return this.no_results(searchText);
      } else {
        this.update_results_content(this.results_option_build());
        return this.winnow_results_set_highlight();
      }
    };

    AbstractChosen.prototype.get_search_regex = function(escaped_search_string) {
      var regex_anchor;
      regex_anchor = this.search_contains ? "" : "^";
      return new RegExp(regex_anchor + escaped_search_string, 'i');
    };

    AbstractChosen.prototype.search_string_match = function(search_string, regex) {
      var part, parts, _i, _len;
      if (regex.test(search_string)) {
        return true;
      } else if (this.enable_split_word_search && (search_string.indexOf(" ") >= 0 || search_string.indexOf("[") === 0)) {
        parts = search_string.replace(/\[|\]/g, "").split(" ");
        if (parts.length) {
          for (_i = 0, _len = parts.length; _i < _len; _i++) {
            part = parts[_i];
            if (regex.test(part)) {
              return true;
            }
          }
        }
      }
    };

    AbstractChosen.prototype.choices_count = function() {
      var option, _i, _len, _ref;
      if (this.selected_option_count != null) {
        return this.selected_option_count;
      }
      this.selected_option_count = 0;
      _ref = this.form_field.options;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        if (option.selected) {
          this.selected_option_count += 1;
        }
      }
      return this.selected_option_count;
    };

    AbstractChosen.prototype.choices_click = function(evt) {
      evt.preventDefault();
      if (!(this.results_showing || this.is_disabled)) {
        return this.results_show();
      }
    };

    AbstractChosen.prototype.keyup_checker = function(evt) {
      var stroke, _ref;
      stroke = (_ref = evt.which) != null ? _ref : evt.keyCode;
      this.search_field_scale();
      switch (stroke) {
        case 8:
          if (this.is_multiple && this.backstroke_length < 1 && this.choices_count() > 0) {
            return this.keydown_backstroke();
          } else if (!this.pending_backstroke) {
            this.result_clear_highlight();
            return this.results_search();
          }
          break;
        case 13:
          evt.preventDefault();
          if (this.results_showing) {
            return this.result_select(evt);
          }
          break;
        case 27:
          if (this.results_showing) {
            this.results_hide();
          }
          return true;
        case 9:
        case 38:
        case 40:
        case 16:
        case 91:
        case 17:
        case 18:
          break;
        default:
          return this.results_search();
      }
    };

    AbstractChosen.prototype.clipboard_event_checker = function(evt) {
      var _this = this;
      return setTimeout((function() {
        return _this.results_search();
      }), 50);
    };

    AbstractChosen.prototype.container_width = function() {
      if (this.options.width != null) {
        return this.options.width;
      } else {
        return "" + this.form_field.offsetWidth + "px";
      }
    };

    AbstractChosen.prototype.include_option_in_results = function(option) {
      if (this.is_multiple && (!this.display_selected_options && option.selected)) {
        return false;
      }
      if (!this.display_disabled_options && option.disabled) {
        return false;
      }
      if (option.empty) {
        return false;
      }
      return true;
    };

    AbstractChosen.prototype.search_results_touchstart = function(evt) {
      this.touch_started = true;
      return this.search_results_mouseover(evt);
    };

    AbstractChosen.prototype.search_results_touchmove = function(evt) {
      this.touch_started = false;
      return this.search_results_mouseout(evt);
    };

    AbstractChosen.prototype.search_results_touchend = function(evt) {
      if (this.touch_started) {
        return this.search_results_mouseup(evt);
      }
    };

    AbstractChosen.prototype.outerHTML = function(element) {
      var tmp;
      if (element.outerHTML) {
        return element.outerHTML;
      }
      tmp = document.createElement("div");
      tmp.appendChild(element);
      return tmp.innerHTML;
    };

    AbstractChosen.browser_is_supported = function() {
      if (/iP(od|hone)/i.test(window.navigator.userAgent)) {
        return false;
      }
      if (/Android/i.test(window.navigator.userAgent)) {
        if (/Mobile/i.test(window.navigator.userAgent)) {
          return false;
        }
      }
      if (/IEMobile/i.test(window.navigator.userAgent)) {
        return false;
      }
      if (/Windows Phone/i.test(window.navigator.userAgent)) {
        return false;
      }
      if (/BlackBerry/i.test(window.navigator.userAgent)) {
        return false;
      }
      if (/BB10/i.test(window.navigator.userAgent)) {
        return false;
      }
      if (window.navigator.appName === "Microsoft Internet Explorer") {
        return document.documentMode >= 8;
      }
      return true;
    };

    AbstractChosen.default_multiple_text = "Select Some Options";

    AbstractChosen.default_single_text = "Select an Option";

    AbstractChosen.default_no_result_text = "No results match";

    return AbstractChosen;

  })();

  $ = jQuery;

  $.fn.extend({
    chosen: function(options) {
      if (!AbstractChosen.browser_is_supported()) {
        return this;
      }
      return this.each(function(input_field) {
        var $this, chosen;
        $this = $(this);
        chosen = $this.data('chosen');
        if (options === 'destroy') {
          if (chosen instanceof Chosen) {
            chosen.destroy();
          }
          return;
        }
        if (!(chosen instanceof Chosen)) {
          $this.data('chosen', new Chosen(this, options));
        }
      });
    }
  });

  Chosen = (function(_super) {
    __extends(Chosen, _super);

    function Chosen() {
      _ref = Chosen.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    Chosen.prototype.setup = function() {
      this.form_field_jq = $(this.form_field);
      this.current_selectedIndex = this.form_field.selectedIndex;
      return this.is_rtl = this.form_field_jq.hasClass("chosen-rtl");
    };

    Chosen.prototype.set_up_html = function() {
      var container_classes, container_props;
      container_classes = ["chosen-container"];
      container_classes.push("chosen-container-" + (this.is_multiple ? "multi" : "single"));
      if (this.inherit_select_classes && this.form_field.className) {
        container_classes.push(this.form_field.className);
      }
      if (this.is_rtl) {
        container_classes.push("chosen-rtl");
      }
      container_props = {
        'class': container_classes.join(' '),
        'style': "width: " + (this.container_width()) + ";",
        'title': this.form_field.title
      };
      if (this.form_field.id.length) {
        container_props.id = this.form_field.id.replace(/[^\w]/g, '_') + "_chosen";
      }
      this.container = $("<div />", container_props);
      if (this.is_multiple) {
        this.container.html('<ul class="chosen-choices"><li class="search-field"><input type="text" value="' + this.default_text + '" class="default" autocomplete="off" style="width:25px;" /></li></ul><div class="chosen-drop"><ul class="chosen-results"></ul></div>');
      } else {
        this.container.html('<a class="chosen-single chosen-default"><span>' + this.default_text + '</span><div><b></b></div></a><div class="chosen-drop"><div class="chosen-search"><input type="text" autocomplete="off" /></div><ul class="chosen-results"></ul></div>');
      }
      this.form_field_jq.hide().after(this.container);
      this.dropdown = this.container.find('div.chosen-drop').first();
      this.search_field = this.container.find('input').first();
      this.search_results = this.container.find('ul.chosen-results').first();
      this.search_field_scale();
      this.search_no_results = this.container.find('li.no-results').first();
      if (this.is_multiple) {
        this.search_choices = this.container.find('ul.chosen-choices').first();
        this.search_container = this.container.find('li.search-field').first();
      } else {
        this.search_container = this.container.find('div.chosen-search').first();
        this.selected_item = this.container.find('.chosen-single').first();
      }
      this.results_build();
      this.set_tab_index();
      return this.set_label_behavior();
    };

    Chosen.prototype.on_ready = function() {
      return this.form_field_jq.trigger("chosen:ready", {
        chosen: this
      });
    };

    Chosen.prototype.register_observers = function() {
      var _this = this;
      this.container.bind('touchstart.chosen', function(evt) {
        _this.container_mousedown(evt);
        return evt.preventDefault();
      });
      this.container.bind('touchend.chosen', function(evt) {
        _this.container_mouseup(evt);
        return evt.preventDefault();
      });
      this.container.bind('mousedown.chosen', function(evt) {
        _this.container_mousedown(evt);
      });
      this.container.bind('mouseup.chosen', function(evt) {
        _this.container_mouseup(evt);
      });
      this.container.bind('mouseenter.chosen', function(evt) {
        _this.mouse_enter(evt);
      });
      this.container.bind('mouseleave.chosen', function(evt) {
        _this.mouse_leave(evt);
      });
      this.search_results.bind('mouseup.chosen', function(evt) {
        _this.search_results_mouseup(evt);
      });
      this.search_results.bind('mouseover.chosen', function(evt) {
        _this.search_results_mouseover(evt);
      });
      this.search_results.bind('mouseout.chosen', function(evt) {
        _this.search_results_mouseout(evt);
      });
      this.search_results.bind('mousewheel.chosen DOMMouseScroll.chosen', function(evt) {
        _this.search_results_mousewheel(evt);
      });
      this.search_results.bind('touchstart.chosen', function(evt) {
        _this.search_results_touchstart(evt);
      });
      this.search_results.bind('touchmove.chosen', function(evt) {
        _this.search_results_touchmove(evt);
      });
      this.search_results.bind('touchend.chosen', function(evt) {
        _this.search_results_touchend(evt);
      });
      this.form_field_jq.bind("chosen:updated.chosen", function(evt) {
        _this.results_update_field(evt);
      });
      this.form_field_jq.bind("chosen:activate.chosen", function(evt) {
        _this.activate_field(evt);
      });
      this.form_field_jq.bind("chosen:open.chosen", function(evt) {
        _this.container_mousedown(evt);
      });
      this.form_field_jq.bind("chosen:close.chosen", function(evt) {
        _this.input_blur(evt);
      });
      this.search_field.bind('blur.chosen', function(evt) {
        _this.input_blur(evt);
      });
      this.search_field.bind('keyup.chosen', function(evt) {
        _this.keyup_checker(evt);
      });
      this.search_field.bind('keydown.chosen', function(evt) {
        _this.keydown_checker(evt);
      });
      this.search_field.bind('focus.chosen', function(evt) {
        _this.input_focus(evt);
      });
      this.search_field.bind('cut.chosen', function(evt) {
        _this.clipboard_event_checker(evt);
      });
      this.search_field.bind('paste.chosen', function(evt) {
        _this.clipboard_event_checker(evt);
      });
      if (this.is_multiple) {
        return this.search_choices.bind('click.chosen', function(evt) {
          _this.choices_click(evt);
        });
      } else {
        return this.container.bind('click.chosen', function(evt) {
          evt.preventDefault();
        });
      }
    };

    Chosen.prototype.destroy = function() {
      $(this.container[0].ownerDocument).unbind("click.chosen", this.click_test_action);
      if (this.search_field[0].tabIndex) {
        this.form_field_jq[0].tabIndex = this.search_field[0].tabIndex;
      }
      this.container.remove();
      this.form_field_jq.removeData('chosen');
      return this.form_field_jq.show();
    };

    Chosen.prototype.search_field_disabled = function() {
      this.is_disabled = this.form_field_jq[0].disabled;
      if (this.is_disabled) {
        this.container.addClass('chosen-disabled');
        this.search_field[0].disabled = true;
        if (!this.is_multiple) {
          this.selected_item.unbind("focus.chosen", this.activate_action);
        }
        return this.close_field();
      } else {
        this.container.removeClass('chosen-disabled');
        this.search_field[0].disabled = false;
        if (!this.is_multiple) {
          return this.selected_item.bind("focus.chosen", this.activate_action);
        }
      }
    };

    Chosen.prototype.container_mousedown = function(evt) {
      if (!this.is_disabled) {
        if (evt && evt.type === "mousedown" && !this.results_showing) {
          evt.preventDefault();
        }
        if (!((evt != null) && ($(evt.target)).hasClass("search-choice-close"))) {
          if (!this.active_field) {
            if (this.is_multiple) {
              this.search_field.val("");
            }
            $(this.container[0].ownerDocument).bind('click.chosen', this.click_test_action);
            this.results_show();
          } else if (!this.is_multiple && evt && (($(evt.target)[0] === this.selected_item[0]) || $(evt.target).parents("a.chosen-single").length)) {
            evt.preventDefault();
            this.results_toggle();
          }
          return this.activate_field();
        }
      }
    };

    Chosen.prototype.container_mouseup = function(evt) {
      if (evt.target.nodeName === "ABBR" && !this.is_disabled) {
        return this.results_reset(evt);
      }
    };

    Chosen.prototype.search_results_mousewheel = function(evt) {
      var delta;
      if (evt.originalEvent) {
        delta = evt.originalEvent.deltaY || -evt.originalEvent.wheelDelta || evt.originalEvent.detail;
      }
      if (delta != null) {
        evt.preventDefault();
        if (evt.type === 'DOMMouseScroll') {
          delta = delta * 40;
        }
        return this.search_results.scrollTop(delta + this.search_results.scrollTop());
      }
    };

    Chosen.prototype.blur_test = function(evt) {
      if (!this.active_field && this.container.hasClass("chosen-container-active")) {
        return this.close_field();
      }
    };

    Chosen.prototype.close_field = function() {
      $(this.container[0].ownerDocument).unbind("click.chosen", this.click_test_action);
      this.active_field = false;
      this.results_hide();
      this.container.removeClass("chosen-container-active");
      this.clear_backstroke();
      this.show_search_field_default();
      return this.search_field_scale();
    };

    Chosen.prototype.activate_field = function() {
      this.container.addClass("chosen-container-active");
      this.active_field = true;
      this.search_field.val(this.search_field.val());
      return this.search_field.focus();
    };

    Chosen.prototype.test_active_click = function(evt) {
      var active_container;
      active_container = $(evt.target).closest('.chosen-container');
      if (active_container.length && this.container[0] === active_container[0]) {
        return this.active_field = true;
      } else {
        return this.close_field();
      }
    };

    Chosen.prototype.results_build = function() {
      this.parsing = true;
      this.selected_option_count = null;
      this.results_data = SelectParser.select_to_array(this.form_field);
      if (this.is_multiple) {
        this.search_choices.find("li.search-choice").remove();
      } else if (!this.is_multiple) {
        this.single_set_selected_text();
        if (this.disable_search || this.form_field.options.length <= this.disable_search_threshold) {
          this.search_field[0].readOnly = true;
          this.container.addClass("chosen-container-single-nosearch");
        } else {
          this.search_field[0].readOnly = false;
          this.container.removeClass("chosen-container-single-nosearch");
        }
      }
      this.update_results_content(this.results_option_build({
        first: true
      }));
      this.search_field_disabled();
      this.show_search_field_default();
      this.search_field_scale();
      return this.parsing = false;
    };

    Chosen.prototype.result_do_highlight = function(el) {
      var high_bottom, high_top, maxHeight, visible_bottom, visible_top;
      if (el.length) {
        this.result_clear_highlight();
        this.result_highlight = el;
        this.result_highlight.addClass("highlighted");
        maxHeight = parseInt(this.search_results.css("maxHeight"), 10);
        visible_top = this.search_results.scrollTop();
        visible_bottom = maxHeight + visible_top;
        high_top = this.result_highlight.position().top + this.search_results.scrollTop();
        high_bottom = high_top + this.result_highlight.outerHeight();
        if (high_bottom >= visible_bottom) {
          return this.search_results.scrollTop((high_bottom - maxHeight) > 0 ? high_bottom - maxHeight : 0);
        } else if (high_top < visible_top) {
          return this.search_results.scrollTop(high_top);
        }
      }
    };

    Chosen.prototype.result_clear_highlight = function() {
      if (this.result_highlight) {
        this.result_highlight.removeClass("highlighted");
      }
      return this.result_highlight = null;
    };

    Chosen.prototype.results_show = function() {
      if (this.is_multiple && this.max_selected_options <= this.choices_count()) {
        this.form_field_jq.trigger("chosen:maxselected", {
          chosen: this
        });
        return false;
      }
      this.container.addClass("chosen-with-drop");
      this.results_showing = true;
      this.search_field.focus();
      this.search_field.val(this.search_field.val());
      this.winnow_results();
      return this.form_field_jq.trigger("chosen:showing_dropdown", {
        chosen: this
      });
    };

    Chosen.prototype.update_results_content = function(content) {
      return this.search_results.html(content);
    };

    Chosen.prototype.results_hide = function() {
      if (this.results_showing) {
        this.result_clear_highlight();
        this.container.removeClass("chosen-with-drop");
        this.form_field_jq.trigger("chosen:hiding_dropdown", {
          chosen: this
        });
      }
      return this.results_showing = false;
    };

    Chosen.prototype.set_tab_index = function(el) {
      var ti;
      if (this.form_field.tabIndex) {
        ti = this.form_field.tabIndex;
        this.form_field.tabIndex = -1;
        return this.search_field[0].tabIndex = ti;
      }
    };

    Chosen.prototype.set_label_behavior = function() {
      var _this = this;
      this.form_field_label = this.form_field_jq.parents("label");
      if (!this.form_field_label.length && this.form_field.id.length) {
        this.form_field_label = $("label[for='" + this.form_field.id + "']");
      }
      if (this.form_field_label.length > 0) {
        return this.form_field_label.bind('click.chosen', function(evt) {
          if (_this.is_multiple) {
            return _this.container_mousedown(evt);
          } else {
            return _this.activate_field();
          }
        });
      }
    };

    Chosen.prototype.show_search_field_default = function() {
      if (this.is_multiple && this.choices_count() < 1 && !this.active_field) {
        this.search_field.val(this.default_text);
        return this.search_field.addClass("default");
      } else {
        this.search_field.val("");
        return this.search_field.removeClass("default");
      }
    };

    Chosen.prototype.search_results_mouseup = function(evt) {
      var target;
      target = $(evt.target).hasClass("active-result") ? $(evt.target) : $(evt.target).parents(".active-result").first();
      if (target.length) {
        this.result_highlight = target;
        this.result_select(evt);
        return this.search_field.focus();
      }
    };

    Chosen.prototype.search_results_mouseover = function(evt) {
      var target;
      target = $(evt.target).hasClass("active-result") ? $(evt.target) : $(evt.target).parents(".active-result").first();
      if (target) {
        return this.result_do_highlight(target);
      }
    };

    Chosen.prototype.search_results_mouseout = function(evt) {
      if ($(evt.target).hasClass("active-result" || $(evt.target).parents('.active-result').first())) {
        return this.result_clear_highlight();
      }
    };

    Chosen.prototype.choice_build = function(item) {
      var choice, close_link,
        _this = this;
      choice = $('<li />', {
        "class": "search-choice"
      }).html("<span>" + (this.choice_label(item)) + "</span>");
      if (item.disabled) {
        choice.addClass('search-choice-disabled');
      } else {
        close_link = $('<a />', {
          "class": 'search-choice-close',
          'data-option-array-index': item.array_index
        });
        close_link.bind('click.chosen', function(evt) {
          return _this.choice_destroy_link_click(evt);
        });
        choice.append(close_link);
      }
      return this.search_container.before(choice);
    };

    Chosen.prototype.choice_destroy_link_click = function(evt) {
      evt.preventDefault();
      evt.stopPropagation();
      if (!this.is_disabled) {
        return this.choice_destroy($(evt.target));
      }
    };

    Chosen.prototype.choice_destroy = function(link) {
      if (this.result_deselect(link[0].getAttribute("data-option-array-index"))) {
        this.show_search_field_default();
        if (this.is_multiple && this.choices_count() > 0 && this.search_field.val().length < 1) {
          this.results_hide();
        }
        link.parents('li').first().remove();
        return this.search_field_scale();
      }
    };

    Chosen.prototype.results_reset = function() {
      this.reset_single_select_options();
      this.form_field.options[0].selected = true;
      this.single_set_selected_text();
      this.show_search_field_default();
      this.results_reset_cleanup();
      this.form_field_jq.trigger("change");
      if (this.active_field) {
        return this.results_hide();
      }
    };

    Chosen.prototype.results_reset_cleanup = function() {
      this.current_selectedIndex = this.form_field.selectedIndex;
      return this.selected_item.find("abbr").remove();
    };

    Chosen.prototype.result_select = function(evt) {
      var high, item;
      if (this.result_highlight) {
        high = this.result_highlight;
        this.result_clear_highlight();
        if (this.is_multiple && this.max_selected_options <= this.choices_count()) {
          this.form_field_jq.trigger("chosen:maxselected", {
            chosen: this
          });
          return false;
        }
        if (this.is_multiple) {
          high.removeClass("active-result");
        } else {
          this.reset_single_select_options();
        }
        high.addClass("result-selected");
        item = this.results_data[high[0].getAttribute("data-option-array-index")];
        item.selected = true;
        this.form_field.options[item.options_index].selected = true;
        this.selected_option_count = null;
        if (this.is_multiple) {
          this.choice_build(item);
        } else {
          this.single_set_selected_text(this.choice_label(item));
        }
        if (!((evt.metaKey || evt.ctrlKey) && this.is_multiple)) {
          this.results_hide();
        }
        this.show_search_field_default();
        if (this.is_multiple || this.form_field.selectedIndex !== this.current_selectedIndex) {
          this.form_field_jq.trigger("change", {
            'selected': this.form_field.options[item.options_index].value
          });
        }
        this.current_selectedIndex = this.form_field.selectedIndex;
        evt.preventDefault();
        return this.search_field_scale();
      }
    };

    Chosen.prototype.single_set_selected_text = function(text) {
      if (text == null) {
        text = this.default_text;
      }
      if (text === this.default_text) {
        this.selected_item.addClass("chosen-default");
      } else {
        this.single_deselect_control_build();
        this.selected_item.removeClass("chosen-default");
      }
      return this.selected_item.find("span").html(text);
    };

    Chosen.prototype.result_deselect = function(pos) {
      var result_data;
      result_data = this.results_data[pos];
      if (!this.form_field.options[result_data.options_index].disabled) {
        result_data.selected = false;
        this.form_field.options[result_data.options_index].selected = false;
        this.selected_option_count = null;
        this.result_clear_highlight();
        if (this.results_showing) {
          this.winnow_results();
        }
        this.form_field_jq.trigger("change", {
          deselected: this.form_field.options[result_data.options_index].value
        });
        this.search_field_scale();
        return true;
      } else {
        return false;
      }
    };

    Chosen.prototype.single_deselect_control_build = function() {
      if (!this.allow_single_deselect) {
        return;
      }
      if (!this.selected_item.find("abbr").length) {
        this.selected_item.find("span").first().after("<abbr class=\"search-choice-close\"></abbr>");
      }
      return this.selected_item.addClass("chosen-single-with-deselect");
    };

    Chosen.prototype.get_search_text = function() {
      return $('<div/>').text($.trim(this.search_field.val())).html();
    };

    Chosen.prototype.winnow_results_set_highlight = function() {
      var do_high, selected_results;
      selected_results = !this.is_multiple ? this.search_results.find(".result-selected.active-result") : [];
      do_high = selected_results.length ? selected_results.first() : this.search_results.find(".active-result").first();
      if (do_high != null) {
        return this.result_do_highlight(do_high);
      }
    };

    Chosen.prototype.no_results = function(terms) {
      var no_results_html;
      no_results_html = $('<li class="no-results">' + this.results_none_found + ' "<span></span>"</li>');
      no_results_html.find("span").first().html(terms);
      this.search_results.append(no_results_html);
      return this.form_field_jq.trigger("chosen:no_results", {
        chosen: this
      });
    };

    Chosen.prototype.no_results_clear = function() {
      return this.search_results.find(".no-results").remove();
    };

    Chosen.prototype.keydown_arrow = function() {
      var next_sib;
      if (this.results_showing && this.result_highlight) {
        next_sib = this.result_highlight.nextAll("li.active-result").first();
        if (next_sib) {
          return this.result_do_highlight(next_sib);
        }
      } else {
        return this.results_show();
      }
    };

    Chosen.prototype.keyup_arrow = function() {
      var prev_sibs;
      if (!this.results_showing && !this.is_multiple) {
        return this.results_show();
      } else if (this.result_highlight) {
        prev_sibs = this.result_highlight.prevAll("li.active-result");
        if (prev_sibs.length) {
          return this.result_do_highlight(prev_sibs.first());
        } else {
          if (this.choices_count() > 0) {
            this.results_hide();
          }
          return this.result_clear_highlight();
        }
      }
    };

    Chosen.prototype.keydown_backstroke = function() {
      var next_available_destroy;
      if (this.pending_backstroke) {
        this.choice_destroy(this.pending_backstroke.find("a").first());
        return this.clear_backstroke();
      } else {
        next_available_destroy = this.search_container.siblings("li.search-choice").last();
        if (next_available_destroy.length && !next_available_destroy.hasClass("search-choice-disabled")) {
          this.pending_backstroke = next_available_destroy;
          if (this.single_backstroke_delete) {
            return this.keydown_backstroke();
          } else {
            return this.pending_backstroke.addClass("search-choice-focus");
          }
        }
      }
    };

    Chosen.prototype.clear_backstroke = function() {
      if (this.pending_backstroke) {
        this.pending_backstroke.removeClass("search-choice-focus");
      }
      return this.pending_backstroke = null;
    };

    Chosen.prototype.keydown_checker = function(evt) {
      var stroke, _ref1;
      stroke = (_ref1 = evt.which) != null ? _ref1 : evt.keyCode;
      this.search_field_scale();
      if (stroke !== 8 && this.pending_backstroke) {
        this.clear_backstroke();
      }
      switch (stroke) {
        case 8:
          this.backstroke_length = this.search_field.val().length;
          break;
        case 9:
          if (this.results_showing && !this.is_multiple) {
            this.result_select(evt);
          }
          this.mouse_on_container = false;
          break;
        case 13:
          if (this.results_showing) {
            evt.preventDefault();
          }
          break;
        case 32:
          if (this.disable_search) {
            evt.preventDefault();
          }
          break;
        case 38:
          evt.preventDefault();
          this.keyup_arrow();
          break;
        case 40:
          evt.preventDefault();
          this.keydown_arrow();
          break;
      }
    };

    Chosen.prototype.search_field_scale = function() {
      var div, f_width, h, style, style_block, styles, w, _i, _len;
      if (this.is_multiple) {
        h = 0;
        w = 0;
        style_block = "position:absolute; left: -1000px; top: -1000px; display:none;";
        styles = ['font-size', 'font-style', 'font-weight', 'font-family', 'line-height', 'text-transform', 'letter-spacing'];
        for (_i = 0, _len = styles.length; _i < _len; _i++) {
          style = styles[_i];
          style_block += style + ":" + this.search_field.css(style) + ";";
        }
        div = $('<div />', {
          'style': style_block
        });
        div.text(this.search_field.val());
        $('body').append(div);
        w = div.width() + 25;
        div.remove();
        f_width = this.container.outerWidth();
        if (w > f_width - 10) {
          w = f_width - 10;
        }
        return this.search_field.css({
          'width': w + 'px'
        });
      }
    };

    return Chosen;

  })(AbstractChosen);

}).call(this);


  }).apply(root, arguments);
});
}(this));

(function(root) {
define("angular-chosen", ["angular","jquery-chosen"], function() {
  return (function() {
/**
 * angular-chosen-localytics - Angular Chosen directive is an AngularJS Directive that brings the Chosen jQuery in a Angular way
 * @version v1.3.0
 * @link http://github.com/leocaseiro/angular-chosen
 * @license MIT
 */
(function() {
  var indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  angular.module('localytics.directives', []);

  angular.module('localytics.directives').directive('chosen', [
    '$timeout', function($timeout) {
      var CHOSEN_OPTION_WHITELIST, NG_OPTIONS_REGEXP, isEmpty, snakeCase;
      NG_OPTIONS_REGEXP = /^\s*([\s\S]+?)(?:\s+as\s+([\s\S]+?))?(?:\s+group\s+by\s+([\s\S]+?))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+([\s\S]+?)(?:\s+track\s+by\s+([\s\S]+?))?$/;
      CHOSEN_OPTION_WHITELIST = ['persistentCreateOption', 'createOptionText', 'createOption', 'skipNoResults', 'noResultsText', 'allowSingleDeselect', 'disableSearchThreshold', 'disableSearch', 'enableSplitWordSearch', 'inheritSelectClasses', 'maxSelectedOptions', 'placeholderTextMultiple', 'placeholderTextSingle', 'searchContains', 'singleBackstrokeDelete', 'displayDisabledOptions', 'displaySelectedOptions', 'width', 'includeGroupLabelInSelected', 'maxShownResults'];
      snakeCase = function(input) {
        return input.replace(/[A-Z]/g, function($1) {
          return "_" + ($1.toLowerCase());
        });
      };
      isEmpty = function(value) {
        var key;
        if (angular.isArray(value)) {
          return value.length === 0;
        } else if (angular.isObject(value)) {
          for (key in value) {
            if (value.hasOwnProperty(key)) {
              return false;
            }
          }
        }
        return true;
      };
      return {
        restrict: 'A',
        require: '?ngModel',
        priority: 1,
        link: function(scope, element, attr, ngModel) {
          var chosen, empty, initOrUpdate, match, options, origRender, startLoading, stopLoading, updateMessage, valuesExpr, viewWatch;
          scope.disabledValuesHistory = scope.disabledValuesHistory ? scope.disabledValuesHistory : [];
          element = $(element);
          element.addClass('localytics-chosen');
          options = scope.$eval(attr.chosen) || {};
          angular.forEach(attr, function(value, key) {
            if (indexOf.call(CHOSEN_OPTION_WHITELIST, key) >= 0) {
              return attr.$observe(key, function(value) {
                options[snakeCase(key)] = String(element.attr(attr.$attr[key])).slice(0, 2) === '{{' ? value : scope.$eval(value);
                return updateMessage();
              });
            }
          });
          startLoading = function() {
            return element.addClass('loading').attr('disabled', true).trigger('chosen:updated');
          };
          stopLoading = function() {
            element.removeClass('loading');
            if (angular.isDefined(attr.disabled)) {
              element.attr('disabled', attr.disabled);
            } else {
              element.attr('disabled', false);
            }
            return element.trigger('chosen:updated');
          };
          chosen = null;
          empty = false;
          initOrUpdate = function() {
            var defaultText;
            if (chosen) {
              return element.trigger('chosen:updated');
            } else {
              $timeout(function() {
                chosen = element.chosen(options).data('chosen');
              });
              if (angular.isObject(chosen)) {
                return defaultText = chosen.default_text;
              }
            }
          };
          updateMessage = function() {
            if (empty) {
              element.attr('data-placeholder', chosen.results_none_found).attr('disabled', true);
            } else {
              element.removeAttr('data-placeholder');
            }
            return element.trigger('chosen:updated');
          };
          if (ngModel) {
            origRender = ngModel.$render;
            ngModel.$render = function() {
              origRender();
              return initOrUpdate();
            };
            element.on('chosen:hiding_dropdown', function() {
              return scope.$apply(function() {
                return ngModel.$setTouched();
              });
            });
            if (attr.multiple) {
              viewWatch = function() {
                return ngModel.$viewValue;
              };
              scope.$watch(viewWatch, ngModel.$render, true);
            }
          } else {
            initOrUpdate();
          }
          attr.$observe('disabled', function() {
            return element.trigger('chosen:updated');
          });
          if (attr.ngOptions && ngModel) {
            match = attr.ngOptions.match(NG_OPTIONS_REGEXP);
            valuesExpr = match[7];
            scope.$watchCollection(valuesExpr, function(newVal, oldVal) {
              var timer;
              return timer = $timeout(function() {
                if (angular.isUndefined(newVal)) {
                  return startLoading();
                } else {
                  empty = isEmpty(newVal);
                  stopLoading();
                  return updateMessage();
                }
              });
            });
            return scope.$on('$destroy', function(event) {
              if (typeof timer !== "undefined" && timer !== null) {
                return $timeout.cancel(timer);
              }
            });
          }
        }
      };
    }
  ]);

}).call(this);


  }).apply(root, arguments);
});
}(this));

/*
# base/frontend/manager/mail/pops/services/emailAccountService.js Copyright(c) 2017 cPanel, Inc.
#                                                                                 All rights Reserved.
# copyright@cpanel.net                                                               http://cpanel.net
# This code is subject to the cPanel license.                       Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/services/emailAccountsService',[
        // Libraries
        "angular",
        "cjt/io/api",
        "cjt/io/uapi-request",
        "cjt/util/locale"
    ],
    function(angular, API, APIREQUEST, LOCALE) { // eslint-disable-line no-unused-vars

        var app;
        try {
            app = angular.module("cpanel.mail.Pops"); // For runtime
        }
        catch (e) {
            app = angular.module("cpanel.mail.Pops", []); // Fall-back for unit testing
        }

        app.factory("emailAccountsService", ["$q", "APIService",
            function($q, APIService) {

                var EmailAccountsService = function() {};
                EmailAccountsService.prototype = new APIService();

                angular.extend(EmailAccountsService.prototype, {

                    _dataWrapper: function(apiCall) {
                        return this.deferred(apiCall, {
                            transformAPISuccess: function(response) {
                                return response.data;
                            }
                        }).promise;
                    },

                    /**
                     * Adds an email account
                     * @method addEmailAccount
                     * @param {Object} emailAccount The email account to add
                     * @return {Promise} Returns a promise that resolves to a string with account+domain
                     */
                    addEmailAccount: function(emailAccount) {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("Email", "add_pop", emailAccount);
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Gets whether or not the shared address book is enabled
                     * @method isSharedAddressBookEnabled
                     * @return {Promise} Returns a promise that resolves to a boolean indicating whether or not the shared AB is enabled
                     */
                    isSharedAddressBookEnabled: function() {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("DAV", "has_shared_global_addressbook");
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Enables the shared address book
                     * @method enableSharedAddressBook
                     * @return {Promise} Returns a promise that resolves to a boolean indicating whether or not the shared AB is enabled
                     */
                    enableSharedAddressBook: function() {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("DAV", "enable_shared_global_addressbook");
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Disables the shared address book
                     * @method disableSharedAddressBook
                     * @return {Promise} Returns a promise that resolves to a boolean indicating whether or not the shared AB is enabled
                     */
                    disableSharedAddressBook: function() {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("DAV", "disable_shared_global_addressbook");
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Changes the password for an email account
                     * @method changePassword
                     * @param  {String} email    A string indicating which email account to change the password for
                     * @param  {String} domain   A string indicating which domain to change the password for
                     * @param  {String} password A string indicating the new password
                     * @return {Promise}         Returns a promise that resolves with no data on success
                     */
                    changePassword: function(email, domain, password) {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("Email", "passwd_pop", {
                            email: email,
                            domain: domain,
                            password: password
                        });
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Changes the quota for an email account
                     * @method changeQuota
                     * @param  {String}  email    A string indicating which email account to change the quota for
                     * @param  {String}  domain   A string indicating which domain to change the quota for
                     * @param  {Integer} quota    An integer specifying the new quota in MB
                     * @return {Promise}          Returns a promise that resolves with no data on success
                     */
                    changeQuota: function(email, domain, quota) {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("Email", "edit_pop_quota", {
                            email: email,
                            domain: domain,
                            quota: quota
                        });
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Deletes an email account
                     * @method deleteEmailAccount
                     * @param  {String}  email    A string indicating which email account to delete
                     * @param  {String}  domain   A string indicating which domain to delete
                     * @return {Promise}          Returns a promise that resolves with no data on success
                     */
                    deleteEmailAccount: function(email, domain) {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("Email", "delete_pop", { email: email, domain: domain });
                        return this._dataWrapper(apiCall);
                    },

                    /**
                     * Gets the list of email accounts
                     * @method getEmailAccounts
                     * @param  {Object}  apiParams An object providing the UAPI filter, paginate, and sort properties
                     * @return {Promise}           Returns a promise that resolves to the list of email accounts
                     */
                    getEmailAccounts: function (apiParams) {

                        if( this.currentGetRequest && this.currentGetRequest.jqXHR ) {
                            this.currentGetRequest.jqXHR.abort();
                        }

                        var apiCall = new APIREQUEST.Class();

                        // We always format the data on the frontend so avoid doing it on the backend for non-displayed data
                        if (!apiParams) {
                          apiParams = {};
                        }
                        apiParams["no_human_readable_keys"] = 1;
                        apiCall.initialize("Email", "list_pops_with_disk", apiParams);

                        var deferred = $q.defer();
                        var service = this;

                        // We want to be able to access the underlying jQuery XHR object here so that we can
                        // .abort() any in flight calls to list_pops_with_disk when a new one is submitted.
                        this.currentGetRequest = new APIService.AngularAPICall(apiCall, {
                            done: function(response) {

                                service.currentGetRequest = undefined;

                                if( response.parsedResponse.error ) {
                                    deferred.reject(response.parsedResponse.error);
                                }
                                else {

                                    var result = response.parsedResponse;

                                    result.data.forEach(function(emailAccount) {

                                        emailAccount.diskused = parseInt(emailAccount.diskused, 10);

                                        if (emailAccount._diskquota === 0 || emailAccount.diskquota === 0 || emailAccount.diskquota === "unlimited") {
                                            emailAccount.diskquota = 0;
                                            emailAccount.humandiskquota = "&infin;";
                                            emailAccount.diskusedpercent = 0;
                                        } else {
                                            emailAccount.diskquota = parseInt(emailAccount.diskquota, 10);
                                            emailAccount.humandiskquota = emailAccount.diskquota;
                                            emailAccount.diskusedpercent = ((emailAccount.diskused / emailAccount.diskquota) * 100).toFixed(2);
                                        }

                                        emailAccount.humandiskusedpercent = LOCALE.maketext("[_1]%", emailAccount.diskusedpercent);
                                        emailAccount.suspended_login = ("" + emailAccount.suspended_login) === "1"; // eslint-disable-line camelcase
                                        emailAccount.suspended_incoming = ("" + emailAccount.suspended_incoming) === "1"; // eslint-disable-line camelcase
                                    });

                                    deferred.resolve(result);
                                }

                            },
                            fail: function() {
                                service.currentGetRequest = undefined;
                            }
                        });

                        return deferred.promise;
                    },

                    /**
                     * Gets the usage for the default email account
                     * @method getDefaultAccountUsage
                     * @return {Promise} Returns a promise that resolves to a pretty formatted string indicating the default account's disk usage
                     */
                    getDefaultAccountUsage: function() {
                        var apiCall = new APIREQUEST.Class();
                        apiCall.initialize("Email", "get_main_account_disk_usage");
                        return this._dataWrapper(apiCall);
                    }

                });

                return new EmailAccountsService();
            }
        ]);

    }
);

/*
# base/frontend/manager/mail/pops/filters/emailLocaleString.js Copyright(c) 2017 cPanel, Inc.
#                                                                              All rights Reserved.
# copyright@cpanel.net                                                            http://cpanel.net
# This code is subject to the cPanel license.                    Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/emailLocaleString',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        /**
         * Filter that accepts an email address and a locale string and returns the localized text
         * @param {String} email        The email address to inject into the locale string
         * @param {String} localeString The locale string to inject the email address into
         *
         * @example
         * <a class="btn btn-link" title="{{ emailAccount.email | emailLocaleString:'Change password for “[_1]”'">
         *
         * NOTE: The locale string passed to this filter must be defined in a maketext string. ## no extract maketext
         */

        var module;

        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("emailLocaleString", function (){
            return function(email, localeString) {
                return LOCALE.makevar(localeString, email);
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/encodeURIComponent.js Copyright(c) 2017 cPanel, Inc.
#                                                                               All rights Reserved.
# copyright@cpanel.net                                                             http://cpanel.net
# This code is subject to the cPanel license.                     Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/encodeURIComponent',[
        "angular",
    ],
    function(angular) {

        /**
         * A filter to provide a wrapper around window.encodeURIComponent for use in Angular markup, mostly useful for building links
         * @param  {String} value The value to provide to encodeURIComponent
         * @return {String}       Returns the value filtered through window.encodeURIComponent
         *
         * @example
         * <a href="../some/page.html#/{{ someValue | encodeURIComponent }}" target="_blank">
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("encodeURIComponent", function() {
            return window.encodeURIComponent;
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/incomingSuspendedTooltip.js Copyright(c) 2017 cPanel, Inc.
#                                                                                     All rights Reserved.
# copyright@cpanel.net                                                                   http://cpanel.net
# This code is subject to the cPanel license.                           Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/incomingSuspendedTooltip',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        /**
         * Filter to generate the title for the incoming suspended icon in the email table
         * @param {Object} emailAccount The email account to generate the title for, should have 'email' and 'suspended_incoming' properties
         *
         * @example
         * <span class="fa-stack fa-lg" title="{{ emailAccount | incomingSuspendedTooltip }}">
         *     <i class="fa fa-upload fa-stack-1x"></i>
         *     <i class="fa fa-ban fa-stack-2x text-danger" ng-if="emailAccount.suspended_incoming"></i>
         * </span>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("incomingSuspendedTooltip", function () {
            return function (emailAccount) {
                if (emailAccount.suspended_incoming) {
                    return LOCALE.maketext("“[_1]” is suspended from receiving mail.", emailAccount.email);
                }
                else {
                    return LOCALE.maketext("“[_1]” can receive mail.", emailAccount.email);
                }
            };
        });

    }

);
/*
# base/frontend/manager/mail/pops/filters/landingPageHref.js Copyright(c) 2017 cPanel, Inc.
#                                                                            All rights Reserved.
# copyright@cpanel.net                                                          http://cpanel.net
# This code is subject to the cPanel license.                  Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/landingPageHref',[
        "angular",
        "cjt/util/query"
    ],
    function(angular, QUERY) {

        /**
         * A filter to generate the href for an email accounts landing page
         * @param  {String} email The email account to generate the link for
         * @param  {String} func  The function on the Email UAPI module to call
         * @return {String}       Returns the href for the landing page
         *
         * @example
         * <a href="{{ emailAccount.email | landingPageHref:'suspend_login' }}">Suspend Login</a>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("landingPageHref", function() {
            return function(email, func) {
                var landingQuery = QUERY.make_query_string({
                    app_key: "email_accounts", // eslint-disable-line camelcase
                    uapi_module: "Email", // eslint-disable-line camelcase
                    uapi_func: func, // eslint-disable-line camelcase
                    uapi_data: JSON.stringify( { email: email } ) // eslint-disable-line camelcase
                });

                return "../../landing.html?" + landingQuery;
            };
        });
    }
);
/*
# base/frontend/manager/mail/pops/filters/loginIncomingHref.js Copyright(c) 2017 cPanel, Inc.
#                                                                              All rights Reserved.
# copyright@cpanel.net                                                            http://cpanel.net
# This code is subject to the cPanel license.                    Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/loginIncomingHref',[
        "angular",
        "cjt/util/query"
    ],
    function(angular, QUERY) {

        /**
         * Filter to build the href for the suspend/unsuspend login and incoming link for an e-mail account
         * @param  {Object} emailAccount The email account to generate the href for, should have 'email' and 'suspended_login' properties
         * @return {String}              The href to use for the suspend/unsuspend login/incoming link
         *
         * Note: This filter should typically be used along with the loginIncomingTooltip and loginIncomingText filters.
         *
         * @example
         * <a title="{{ emailAccount | loginIncomingTooltip }}" href="{{ emailAccount | loginIncomingHref }}">{{ emailAccount | loginIncomingText }}</a>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("loginIncomingHref", function() {
            return function(emailAccount) {

                var action = emailAccount.suspended_login ? "unsuspend" : "suspend";

                var queryString = QUERY.make_query_string({
                    app_key: "email_accounts", // eslint-disable-line camelcase

                    uapi_module: "Batch", // eslint-disable-line camelcase
                    uapi_func: "strict", // eslint-disable-line camelcase

                    uapi_data: JSON.stringify({ // eslint-disable-line camelcase
                        "command": JSON.stringify([ "Email", action + "_incoming", { email: emailAccount.email } ]),
                        "command-0": JSON.stringify([ "Email", action + "_login", { email: emailAccount.email } ])
                    })
                });

                return "../../landing.html?" + queryString;
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/loginIncomingText.js Copyright(c) 2017 cPanel, Inc.
#                                                                              All rights Reserved.
# copyright@cpanel.net                                                            http://cpanel.net
# This code is subject to the cPanel license.                    Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/loginIncomingText',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        /**
         * Filter to build the text for the suspend/unsuspend login and incoming link for an e-mail account
         * @param  {Object} emailAccount The email account to generate the href for, should have 'email' and 'suspended_login' properties
         * @return {String}              The text to use for the suspend/unsuspend login/incoming link
         *
         * Note: This filter should typically be used along with the loginIncomingTooltip and loginIncomingHref filters.
         *
         * @example
         * <a title="{{ emailAccount | loginIncomingTooltip }}" href="{{ emailAccount | loginIncomingHref }}">{{ emailAccount | loginIncomingText }}</a>
         */


        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("loginIncomingText", function() {
            return function(emailAccount) {
                return emailAccount.suspended_login ? LOCALE.maketext("Unsuspend") : LOCALE.maketext("Suspend");
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/loginIncomingTooltip.js Copyright(c) 2017 cPanel, Inc.
#                                                                                 All rights Reserved.
# copyright@cpanel.net                                                               http://cpanel.net
# This code is subject to the cPanel license.                       Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/loginIncomingTooltip',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        /**
         * Filter to build the title for the suspend/unsuspend login and incoming link for an e-mail account
         * @param  {Object} emailAccount The email account to generate the href for, should have 'email' and 'suspended_login' properties
         * @return {String}              The title to use for the suspend/unsuspend login/incoming link
         *
         * Note: This filter should typically be used along with the loginIncomingText and loginIncomingHref filters.
         *
         * @example
         * <a title="{{ emailAccount | loginIncomingTooltip }}" href="{{ emailAccount | loginIncomingHref }}">{{ emailAccount | loginIncomingText }}</a>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("loginIncomingTooltip", function() {
            return function(emailAccount) {
                if( emailAccount.suspended_login ) {
                    return LOCALE.maketext("Allow “[_1]” to log in and to receive mail.", emailAccount.email);
                }
                else {
                    return LOCALE.maketext("Suspend “[_1]”’s logins and incoming mail.", emailAccount.email);
                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/loginSuspendedTooltip.js Copyright(c) 2017 cPanel, Inc.
#                                                                                  All rights Reserved.
# copyright@cpanel.net                                                                http://cpanel.net
# This code is subject to the cPanel license.                        Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/loginSuspendedTooltip',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        /**
         * Filter to generate the title for the login suspended icon in the email table
         * @param {Object} emailAccount The email account to generate the title for, should have 'email' and 'suspended_login' properties
         *
         * @example
         * <span class="fa-stack fa-lg" title="{{ emailAccount | loginSuspendedTooltip }}">
         *     <i class="fa fa-upload fa-stack-1x"></i>
         *     <i class="fa fa-ban fa-stack-2x text-danger" ng-if="emailAccount.suspended_login"></i>
         * </span>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("loginSuspendedTooltip", function () {
            return function (emailAccount) {
                if (emailAccount.suspended_login) {
                    return LOCALE.maketext("“[_1]” is suspended from sending and reading mail.", emailAccount.email);
                }
                else {
                    return LOCALE.maketext("“[_1]” can send and receive mail.", emailAccount.email);
                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/filters/quotaProgressType.js Copyright(c) 2017 cPanel, Inc.
#                                                                              All rights Reserved.
# copyright@cpanel.net                                                            http://cpanel.net
# This code is subject to the cPanel license.                    Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/filters/quotaProgressType',[
        "angular"
    ],
    function() {

        /**
         * Filter that returns the progress bar class to use based on the percentage used
         * @param {Integer} displayPercentage The percentage (0-100) to check
         * @return {String}                   Returns a string indicating the class name to apply to the progress bar
         *
         * @example
         * <uib-progressbar type="{{ emailAccount.diskusedpercent | quotaProgressType }}" value="emailAccount.diskusedpercent"></uib-progressbar>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.filter("quotaProgressType", function() {
            return function(displayPercentage) {
                if (displayPercentage >= 80) {
                    return "danger";
                }
                else if (displayPercentage >= 60) {
                    return "warning";
                }
                else if (displayPercentage >= 40) {
                    return "info";
                }
                else {
                    return "success";
                }
            };
        });

    }
);

/*
# base/frontend/manager/mail/pops/views/listEmailAccounts.js Copyright(c) 2017 cPanel, Inc.
#                                                                            All rights Reserved.
# copyright@cpanel.net                                                          http://cpanel.net
# This code is subject to the cPanel license.                  Unauthorized copying is prohibited
*/

/* global define: false, PAGE: false */

define(
    'app/views/listEmailAccounts',[
        "lodash",
        "angular",
        "cjt/util/locale",
        "uiBootstrap",
        "cjt/directives/actionButtonDirective",
        "cjt/directives/loadingPanel",
        "cjt/directives/toggleSortDirective",
        "cjt/directives/searchDirective",
        "cjt/directives/pageSizeDirective",
        "cjt/filters/startFromFilter",
        "cjt/decorators/paginationDecorator",
        "cjt/services/ComponentSettingSaverService"
    ],
    function(_, angular, LOCALE) {

        var app;
        try {
            app = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            app = angular.module("cpanel.mail.Pops", []);
        }

        app.controller("listEmailAccountsCtrl",
            ["$rootScope", "$scope", "$timeout", "emailAccountsService", "growl", "$window", "ComponentSettingSaverService",
                function($rootScope, $scope, $timeout, emailAccountsService, growl, $window, ComponentSettingSaverService) {

                    var COMPONENT_NAME = "EmailAccountsTable";
                    $scope.emailAccounts = [];
                    $scope.filteredList = [];

                    $scope.requiredPasswordStrength = PAGE.requiredPasswordStrength;
                    $scope.webmailEnabled = PAGE.webmailEnabled;
                    $scope.externalAuthConfig = PAGE.externalAuthModulesConfigured;
                    $scope.showCalAndContacts = PAGE.showCalendarAndContactItems;
                    $scope.emailDiskUsageEnabled = PAGE.emailDiskUsageEnabled;
                    $scope.defaultQuota = PAGE.userDefinedQuotaDefaultValue;
                    $scope.maxQuota = PAGE.maxEmailQuota;
                    $scope.expandedAccount = undefined;
                    $scope.loadingEmailAccounts = false;

                    $scope.actionModule = undefined;

                    $scope.passwordChange = {
                        password: undefined,
                        confirm: undefined
                    };

                    $scope.changingPassword = false;

                    $scope.quotaChange = {
                        quotaType: undefined,
                        quota: undefined
                    };

                    $scope.changingQuota = false;

                    $scope.meta = {
                    // sort settings
                        sortReverse: false,
                        sortBy: "user",
                        sortDirection: "asc",
                        sortFields: ["user", "domain", "_diskused", "_diskquota", "diskusedpercent"],

                        // search settings
                        filterValue: "",

                        // pager settings
                        maxPages: 5,
                        totalItems: $scope.emailAccounts.length,
                        currentPage: 1,
                        pageSize: 20,
                        pageSizes: [20, 50, 100, 500],
                        start: 0,
                        limit: 10
                    };

                    $scope.setMetaFromComponentSettings = function(settings) {

                        if( settings.hasOwnProperty("sortBy") && settings.sortBy && _.find($scope.meta.sortFields, function(f) { return f === settings.sortBy; }) ) {
                            $scope.meta.sortBy = settings.sortBy;
                        }

                        if( settings.hasOwnProperty("sortDirection") && settings.sortDirection && (settings.sortDirection === "asc" || settings.sortDirection === "desc" ) ) {
                            $scope.meta.sortDirection = settings.sortDirection;
                        }

                        if( settings.hasOwnProperty("pageSize") && settings.pageSize && _.find($scope.meta.pageSizes, function(s) { return s === parseInt(settings.pageSize); }) ) {
                            $scope.meta.pageSize = parseInt(settings.pageSize);
                        }

                        if( settings.hasOwnProperty("filterValue") ) {
                            $scope.meta.filterValue = settings.filterValue;
                        }

                    };

                    $scope.saveMetaToComponentSettings = function() {
                        ComponentSettingSaverService.set(COMPONENT_NAME, {
                            sortBy: $scope.meta.sortBy,
                            sortDirection: $scope.meta.sortDirection,
                            pageSize: $scope.meta.pageSize,
                            filterValue: $scope.meta.filterValue
                        });
                    };

                    $scope.clearStatus = function() {
                        $scope.expandedAccount.status = undefined;
                    };

                    $scope.onMenuToggle = function(index) {
                        var dropdownContainer = angular.element("#email_table_menu_" + index);
                        if( !dropdownContainer || dropdownContainer.length !== 1 ) {
                            return;
                        }

                        dropdownContainer = dropdownContainer[0];
                        var position = dropdownContainer.getBoundingClientRect().top;
                        var buttonHeight = dropdownContainer.getBoundingClientRect().height;

                        var dropdownMenu = angular.element("#email_table_menu_" + index + " .dropdown-menu");
                        if( !dropdownMenu || dropdownMenu.length !== 1 ) {
                            return;
                        }

                        dropdownMenu = dropdownMenu[0];
                        var menuHeight = parseInt($window.getComputedStyle(dropdownMenu).height);

                        $scope.isDropUp = position > menuHeight && $window.innerHeight - position < buttonHeight + menuHeight;
                    };

                    /**
                     * Generic click handler for the cancel links in action modules
                     */
                    $scope.cancelAction = function() {
                        $scope.expandedAccount = undefined;
                        $scope.actionModule = undefined;
                    };

                    /**
                     * Click handler for the password link, opens the change password module for the account
                     * @param  {Object} emailAccount The email account to open the change password module for
                     */
                    $scope.onClickPassword = function(emailAccount) {

                        $scope.passwordChange = {};

                        if( $scope.expandedAccount === emailAccount && $scope.actionModule === "password" ) {
                            $scope.actionModule = undefined;
                        }
                        else {
                            if( $scope.expandedAccount ) {
                                $scope.expandedAccount.status = undefined;
                            }
                            $scope.actionModule = "password";
                            $scope.expandedAccount = emailAccount;
                        }
                    };

                    /**
                     * Click handler for the change password button, submits the new password to emailAccountsService.changePassword
                     */
                    $scope.onClickChangePassword = function() {

                        $scope.changingPassword = true;
                        $scope.expandedAccount.status = undefined;

                        return emailAccountsService.changePassword($scope.expandedAccount.user, $scope.expandedAccount.domain, $scope.passwordChange.password).then(
                            function() {

                                $scope.expandedAccount.status = {
                                    message: LOCALE.maketext("Password for “[_1]” has been changed.", $scope.expandedAccount.user + "@" + $scope.expandedAccount.domain),
                                    type: "success",
                                    closeable: true,
                                    ttl: 10000
                                };

                                $scope.changingPassword = false;
                                $scope.passwordChange = {};
                                $scope.actionModule = undefined;
                            },
                            function(error) {
                                if( $scope.expandedAccount ) {
                                    $scope.expandedAccount.status = undefined;
                                }
                                $scope.expandedAccount.status = { type: "danger", message: error };
                                $scope.changingPassword = false;
                            }
                        );

                    };

                    /**
                     * Click handler for the quota link, opens the change quota module for the account
                     * @param  {Object} emailAccount The email account to open the change quota module for
                     */
                    $scope.onClickQuota = function(emailAccount) {
                        if( $scope.expandedAccount === emailAccount && $scope.actionModule === "quota" ) {
                            $scope.actionModule = undefined;
                        }
                        else {

                            if( $scope.expandedAccount ) {
                                $scope.expandedAccount.status = undefined;
                            }

                            $scope.actionModule = "quota";
                            $scope.expandedAccount = emailAccount;

                            if( !emailAccount._diskquota || emailAccount._diskquota === 0 ) {
                                $scope.quotaChange.quotaType = "unlimited";
                                $scope.quotaChange.quota = $scope.defaultQuota;
                            }
                            else {
                                $scope.quotaChange.quotaType = "userdefined";
                                $scope.quotaChange.quota = emailAccount.diskquota;
                            }
                        }
                    };

                    /**
                     * Click handler for the save button on the change quota module, submits the new quota to emailAccountsService.changeQuota
                     */
                    $scope.onClickChangeQuota = function() {

                        $scope.changingQuota = true;
                        $scope.expandedAccount.status = undefined;

                        var emailAccount = $scope.expandedAccount;
                        var quotaValue = $scope.quotaChange.quotaType === "unlimited" ? 0 : $scope.quotaChange.quota;

                        return emailAccountsService.changeQuota(emailAccount.user, emailAccount.domain, quotaValue).then(
                            function() {

                                $scope.changingQuota = false;

                                var statusText;

                                if( $scope.quotaChange.quotaType === "unlimited" ) {
                                    statusText = LOCALE.maketext("Changed Quota for “[_1]” to unlimited.", emailAccount.user + "@" + emailAccount.domain);
                                }
                                else {
                                    statusText = LOCALE.maketext("Changed Quota for “[_1]” to [numf,_2] MB.", emailAccount.user + "@" + emailAccount.domain, quotaValue);
                                }

                                $scope.expandedAccount.status = {
                                    type: "success",
                                    message: statusText,
                                    closeable: true,
                                    ttl: 10000
                                };

                                if( $scope.quotaChange.quotaType === "unlimited" || quotaValue === 0 ) {
                                    emailAccount._diskquota = 0;
                                    emailAccount.diskquota = "unlimited";
                                    emailAccount.humandiskquota = "&infin;";
                                    emailAccount.diskusedpercent = 0;
                                }
                                else {
                                    emailAccount._diskquota = quotaValue;
                                    emailAccount.diskquota = quotaValue;
                                    emailAccount.humandiskquota = quotaValue;
                                    emailAccount.diskusedpercent = ((emailAccount.diskused / emailAccount.diskquota) * 100).toFixed(2);
                                }

                                emailAccount.humandiskusedpercent = LOCALE.maketext("[_1]%", emailAccount.diskusedpercent);

                                $scope.actionModule = undefined;
                            },
                            function(error) {
                                $scope.changingQuota = false;
                                $scope.expandedAccount.status = { type: "danger", message: error };
                            }
                        );
                    };

                    /**
                     * Click handler for the delete link, opens the delete module for the account
                     * @param  {Object} emailAccount The email account to open the delete module for
                     */
                    $scope.onClickDelete = function(emailAccount) {
                        if( $scope.expandedAccount === emailAccount && $scope.actionModule === "delete" ) {
                            $scope.actionModule = undefined;
                        }
                        else {

                            if( $scope.expandedAccount ) {
                                $scope.expandedAccount.status = undefined;
                            }

                            $scope.actionModule = "delete";
                            $scope.expandedAccount = emailAccount;
                        }
                    };

                    /**
                     * Click handler for the delete button on the delete module, submits the account to emailAccountService.deleteEmailAccount
                     */
                    $scope.onClickDeleteConfirm = function() {

                        $scope.deletingAccount = true;
                        $scope.expandedAccount.status = undefined;
                        $scope.expandedAccount.deleting = true;

                        return emailAccountsService.deleteEmailAccount($scope.expandedAccount.user, $scope.expandedAccount.domain).then(
                            function() {

                                $scope.expandedAccount.deleted = true;
                                $scope.expandedAccount.status = {
                                    message: LOCALE.maketext("Account “[_1]” deleted.", $scope.expandedAccount.user + "@" + $scope.expandedAccount.domain),
                                    type: "success",
                                    closeable: true,
                                    ttl: 10000
                                };

                                $scope.deletingAccount = false;
                                $scope.actionModule = undefined;
                            },
                            function(error) {
                                $scope.expandedAccount.status = { type: "danger", message: error };
                                $scope.deletingAccount = false;
                            }
                        );
                    };

                    /**
                     * Callback for clicking on one of the table headers to sort by column
                     */
                    $scope.sortList = function() {

                        if( $scope.currentFetchTimeout ) {
                            $timeout.cancel($scope.currentFetchTimeout);
                        }

                        $scope.currentFetchTimeout = $timeout(function() {
                            $scope.saveMetaToComponentSettings();
                            $scope.meta.currentPage = 1;
                            $scope.fetch();
                        }, 250);
                    };

                    /**
                     * Callback for clicking on one of the pagination nav links to move between pages
                     */
                    $scope.selectPage = function() {

                        if( $scope.currentFetchTimeout ) {
                            $timeout.cancel($scope.currentFetchTimeout);
                        }

                        $scope.currentFetchTimeout = $timeout(function() {
                            $scope.fetch();
                        }, 250);
                    };

                    /**
                     * Callback for selecting a page size from the pagination <select>
                     */
                    $scope.selectPageSize = function() {

                        if( $scope.currentFetchTimeout ) {
                            $timeout.cancel($scope.currentFetchTimeout);
                        }

                        $scope.currentFetchTimeout = $timeout(function() {
                            $scope.saveMetaToComponentSettings();
                            $scope.meta.currentPage = 1;
                            $scope.fetch();
                        }, 250);
                    };

                    /**
                     * Callback for entering filter input into the search bar
                     */
                    $scope.searchList = function() {

                        $scope.filterTermPending = true;

                        if( $scope.currentFetchTimeout ) {
                            $timeout.cancel($scope.currentFetchTimeout);
                        }

                        $scope.currentFetchTimeout = $timeout(function() {
                            $scope.saveMetaToComponentSettings();
                            $scope.meta.currentPage = 1;
                            $scope.fetch();
                        }, 250);
                    };

                    /**
                     * Callback that clears the expandedAccount field after all open modules have been collapsed
                     */
                    $scope.collapseFinished = function() {
                        if( $scope.actionModule === undefined ) {
                            $scope.expandedAccount = undefined;
                        }
                    };

                    /**
                     * Calls emailAccountsService.getEmailAccounts to load the email accounts for the current page
                     */
                    $scope.fetch = function() {

                        $scope.loadingEmailAccounts = true;
                        $scope.meta.mobileItemCountText = undefined;

                        var sortMethod = "lexicographic";

                        if( $scope.meta.sortBy === "_diskused" || $scope.meta.sortBy === "diskusedpercent" ) {
                            sortMethod = "numeric";
                        }
                        else if( $scope.meta.sortBy === "_diskquota" ) {
                            sortMethod = "numeric_zero_as_max";
                        }

                        var apiParams = {
                            "api.sort": 1,
                            "api.sort_column": $scope.meta.sortBy,
                            "api.sort_method": sortMethod,
                            "api.sort_reverse": $scope.meta.sortDirection === "asc" ? 0 : 1,
                            "api.paginate": 1,
                            "api.paginate_start": ($scope.meta.currentPage - 1) * $scope.meta.pageSize,
                            "api.paginate_size": $scope.meta.pageSize,
                            "api.paginate_page": $scope.meta.currentPage
                        };

                        if( $scope.meta.filterValue && $scope.meta.filterValue !== "" ) {
                            apiParams["api.filter"] = 1;
                            apiParams["api.filter_term_0"] = $scope.meta.filterValue;
                            apiParams["api.filter_column_0"] = "login";
                        }

                        $scope.filteredList = [];

                        // Setting min-height to the current height to prevent the page jumping
                        // around when the list is fetching
                        var container = angular.element("#popsAccountList");

                        if( container && container[0] ) {
                            container.css({ minHeight: $window.getComputedStyle(container[0]).height });
                        }

                        var apiPromise = emailAccountsService.getEmailAccounts(apiParams);
                        $scope.fetchPromise = apiPromise;

                        apiPromise.then(
                            function(response) {

                                // We only want to actually process the response if it's the last request we sent
                                if( $scope.fetchPromise !== apiPromise ) {
                                    return;
                                }

                                var data = response.data;
                                var metadata = response.meta;

                                $scope.meta.totalItems = metadata.paginate.total_records;

                                if ($scope.meta.totalItems > _.min($scope.meta.pageSizes)) {
                                    $scope.showPager = true;
                                    var start = ($scope.meta.currentPage - 1) * $scope.meta.pageSize;
                                    $scope.meta.start = start + 1;
                                    $scope.meta.limit = start + data.length;

                                } else {
                                // hide pager and pagination
                                    $scope.showPager = false;

                                    if (data.length === 0) {
                                        $scope.meta.start = 0;
                                    } else {
                                    // table statistics
                                        $scope.meta.start = 1;
                                    }

                                    $scope.meta.limit = data.length;
                                }

                                $scope.meta.mobileItemCountText = LOCALE.maketext("Displaying [_1] to [_2] out of [_3] records",
                                    $scope.meta.start, $scope.meta.limit, $scope.meta.totalItems
                                );

                                angular.element("#popsAccountList").css({ minHeight: "" });
                                $scope.filteredList = data;
                                $scope.loadingEmailAccounts = false;
                                $scope.filterTermPending = false;
                            },
                            function(error) {
                                growl.error(error);
                                $scope.loadingEmailAccounts = false;
                                $scope.filterTermPending = false;
                            }
                        );

                    };

                    $scope.getSearchClass = function() {
                        if( !$scope.filterTermPending && !$scope.loadingEmailAccounts && $scope.meta.filterValue ) {
                            return $scope.filteredList.length > 0 ? "success" : "danger";
                        }
                        else {
                            return "";
                        }
                    };

                    var unregisterAddListener = $rootScope.$on("emailAccountAdded", $scope.fetch);

                    if( PAGE.nvdata && PAGE.nvdata.hasOwnProperty(COMPONENT_NAME) ) {
                        $scope.setMetaFromComponentSettings(PAGE.nvdata[COMPONENT_NAME]);
                    }

                    $scope.$on("$destroy", function() {
                        ComponentSettingSaverService.unregister(COMPONENT_NAME);
                        unregisterAddListener();
                    });

                    ComponentSettingSaverService.register(COMPONENT_NAME);
                    $timeout($scope.fetch);
                }]
        );

    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountAllowedChars.js Copyright(c) 2017 cPanel, Inc.
#                                                                                        All rights Reserved.
# copyright@cpanel.net                                                                      http://cpanel.net
# This code is subject to the cPanel license.                              Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/validators/emailAccountAllowedChars',[
        "angular"
    ],
    function(angular) {

        /**
         * Directive that checks to make sure an input only allows a-z, A-Z, 0-9, ., -, and _
         *
         * @example
         * <input type="text" name="account" email-allowed-chars>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailAllowedChars", function () {
            return {
                require: "ngModel",
                restrict: "A",
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars
                    //"You can only enter letters, numbers, periods, hyphens, and underscores."
                    var pattern = /[^a-zA-Z0-9.\-_]/;

                    ngModel.$validators.emailAllowedChars = function(model, view) { // eslint-disable-line no-unused-vars
                        if( !ngModel.$isEmpty(view) ) {
                            return !pattern.test(view);
                        }
                        return true;
                    };
                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountFullLength.js Copyright(c) 2017 cPanel, Inc.
#                                                                                      All rights Reserved.
# copyright@cpanel.net                                                                    http://cpanel.net
# This code is subject to the cPanel license.                            Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/validators/emailAccountFullLength',[
        "angular"
    ],
    function(angular) {

        var module;

        /**
         * Directive that checks the full length of two form fields + 1 (for the @) to make sure an email address is a valid length
         * @attribute {Integer} emailFullLength The maximum allowed length for the two fields + 1
         * @attribute {String}  emailOtherValue The other form field to compare against
         *
         * @example
         * <form name="formName">
         *     <input type="text" name="account" email-full-length="254" email-other-value="formName.domain">
         *     <input type="text" name="domain">
         * </form>
         */

        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailFulllength", function () {
            return {
                require: "ngModel",
                restrict: "A",
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars

                    ngModel.$validators.emailFulllength = function(model, view) { // eslint-disable-line no-unused-vars

                        var ngOtherModel = getNgOtherModel();
                        if (!ngOtherModel) {
                            var value = view || "";
                            return (value.length + 1) <= attrs.emailFulllength;
                        }

                        var thisIsEmpty = ngModel.$isEmpty(view);
                        var otherIsEmpty = ngOtherModel.$isEmpty(ngOtherModel.$viewValue);
                        if(thisIsEmpty && otherIsEmpty) {
                            // Don't validate this condition if both values are empty
                            return true;
                        }
                        else {

                            var thisValue = view || "";
                            var otherValue = (ngOtherModel.$pending || ngOtherModel.$invalid) ? ngOtherModel.$viewValue : ngOtherModel.$modelValue;

                            return (thisValue.length + otherValue.length + 1) <= attrs.emailFulllength;
                        }

                    };

                    scope.$watchGroup([
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$viewValue;
                        },
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$modelValue;
                        }
                    ], function() {
                        ngModel.$validate();
                    });

                    var _ngOtherModel;
                    function getNgOtherModel() {
                        if(!_ngOtherModel) {
                            _ngOtherModel = scope.$eval(attrs.emailOtherValue);
                        }
                        return _ngOtherModel;
                    }
                }
            };
        });
    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountMaxQuota.js Copyright(c) 2017 cPanel, Inc.
#                                                                                    All rights Reserved.
# copyright@cpanel.net                                                                  http://cpanel.net
# This code is subject to the cPanel license.                          Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/validators/emailAccountMaxQuota',[
        "angular"
    ],
    function(angular) {

        /**
         * Directive that checks an input field for a maximum value, but only if another field is not set to unlimited
         * @attribute {Integer} emailMaxQuota  - The maximum value allowed for the field
         * @attribute {String}  emailQuotaType - A string indicating the other form field to check for the "unlimited" value
         *
         * @example
         * <form name="formName">
         *     <div>
         *          <input id="userdefinedquota" type="radio" name="quotaType" value="userdefined">
         *          <input type="number" name="quota" email-max-quota="1234567890" email-quota-type="formName.quotaType">
         *          <span>MB</span>
         *     </div>
         *     <div>
         *         <input id="unlimitedquota" type="radio" name="quotaType" value="unlimited">
         *         <label for="unlimitedquota">Unlimited</label>
         *     </div>
         * </form>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailMaxQuota", function () {
            return {
                require: "ngModel",
                restrict: "A",
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars

                    ngModel.$validators.emailMaxQuota = function(model, view) { // eslint-disable-line no-unused-vars

                        var quotaTypeModel = getNgOtherModel();
                        if( !quotaTypeModel ) {
                            return true;
                        }

                        var otherIsEmpty = quotaTypeModel.$isEmpty(quotaTypeModel.$viewValue);
                        if( otherIsEmpty ) {
                            // Somehow they deselected the radio button, skip this validation
                            return true;
                        }

                        if( quotaTypeModel.$viewValue !== "unlimited" ) {
                            if( ngModel.$isEmpty(view) ) {
                                // We have no value, skip this validation and let required take care of it
                                return true;
                            }
                            else if( isNaN(view) ) {
                                // Value is not a number, let the numeric validator handle it
                                return true;
                            }
                            else {
                                var maxQuota = parseInt(attrs.emailMaxQuota, 10);
                                return view <= maxQuota;
                            }
                        }
                        else {
                            return true;
                        }


                    };

                    scope.$watchGroup([
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$viewValue;
                        },
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$modelValue;
                        }
                    ], function() {
                        ngModel.$validate();
                    });

                    var _ngOtherModel;
                    function getNgOtherModel() {
                        if(!_ngOtherModel) {
                            _ngOtherModel = scope.$eval(attrs.emailQuotaType);
                        }
                        return _ngOtherModel;
                    }

                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountMinQuota.js Copyright(c) 2017 cPanel, Inc.
#                                                                                    All rights Reserved.
# copyright@cpanel.net                                                                  http://cpanel.net
# This code is subject to the cPanel license.                          Unauthorized copying is prohibited
*/

/* global define: false */
define(
    'app/validators/emailAccountMinQuota',[
        "angular"
    ],
    function(angular) {

        /**
         * Directive that checks an input field for a minimum value, but only if another field is not set to unlimited
         * @attribute {Integer} emailMinQuota  - The minimum value allowed for the field
         * @attribute {String}  emailQuotaType - A string indicating the other form field to check for the "unlimited" value
         *
         * @example
         * <form name="formName">
         *     <div>
         *          <input id="userdefinedquota" type="radio" name="quotaType" value="userdefined">
         *          <input type="number" name="quota" email-min-quota="0" email-quota-type="formName.quotaType">
         *          <span>MB</span>
         *     </div>
         *     <div>
         *         <input id="unlimitedquota" type="radio" name="quotaType" value="unlimited">
         *         <label for="unlimitedquota">Unlimited</label>
         *     </div>
         * </form>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailMinQuota", function () {
            return {
                require: "ngModel",
                restrict: "A",
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars

                    ngModel.$validators.emailMinQuota = function(model, view) { // eslint-disable-line no-unused-vars

                        var quotaTypeModel = getNgOtherModel();
                        if( !quotaTypeModel ) {
                            return true;
                        }

                        var otherIsEmpty = quotaTypeModel.$isEmpty(quotaTypeModel.$viewValue);
                        if( otherIsEmpty ) {
                            // Somehow they deselected the radio button, skip this validation
                            return true;
                        }

                        if( quotaTypeModel.$viewValue !== "unlimited" ) {
                            if( ngModel.$isEmpty(view) ) {
                                // We have no value, skip this validation and let required take care of it
                                return true;
                            }
                            else if( isNaN(view) ) {
                                // Value is not a number, let the numeric validator handle it
                                return true;
                            }
                            else {
                                var minQuota = parseInt(attrs.emailMinQuota, 10);
                                return view >= minQuota;
                            }
                        }
                        else {
                            return true;
                        }

                    };

                    scope.$watchGroup([
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$viewValue;
                        },
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$modelValue;
                        }
                    ], function() {
                        ngModel.$validate();
                    });

                    var _ngOtherModel;
                    function getNgOtherModel() {
                        if(!_ngOtherModel) {
                            _ngOtherModel = scope.$eval(attrs.emailQuotaType);
                        }
                        return _ngOtherModel;
                    }

                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountMaxQuota.js Copyright(c) 2017 cPanel, Inc.
#                                                                                    All rights Reserved.
# copyright@cpanel.net                                                                  http://cpanel.net
# This code is subject to the cPanel license.                          Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/validators/emailAccountNumericQuota',[
        "angular"
    ],
    function(angular) {

        /**
         * Directive that checks an input[type="number"] field for a positive integer, but only if another field is not set to unlimited
         * @attribute {String}  emailQuotaType - A string indicating the other form field to check for the "unlimited" value
         *
         * @example
         * <form name="formName">
         *     <div>
         *          <input id="userdefinedquota" type="radio" name="quotaType" value="userdefined">
         *          <input type="text" name="quota" email-numeric-quota email-quota-type="formName.quotaType">
         *          <span>MB</span>
         *     </div>
         *     <div>
         *         <input id="unlimitedquota" type="radio" name="quotaType" value="unlimited">
         *         <label for="unlimitedquota">Unlimited</label>
         *     </div>
         * </form>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailNumericQuota", function () {
            return {
                require: "ngModel",
                restrict: "A",
                priority: 2,
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars

                    var testViewValue = function(view, testFunc) {

                        var quotaTypeModel = getNgOtherModel();
                        if( !quotaTypeModel ) {
                            return true;
                        }

                        var otherIsEmpty = quotaTypeModel.$isEmpty(quotaTypeModel.$viewValue);
                        if( otherIsEmpty ) {
                            // Somehow they deselected the radio button, skip this validation
                            return true;
                        }

                        if( quotaTypeModel.$viewValue !== "unlimited" ) {
                            if( ngModel.$isEmpty(view) ) {
                                // We have no value, skip this validation and let required take care of it
                                return true;
                            }
                            else {
                                return testFunc(view);
                            }
                        }
                        else {
                            return true;
                        }

                    };

                    ngModel.$validators.number = function(model, view) { // eslint-disable-line no-unused-vars

                        return testViewValue(view, function(view) {
                            return !isNaN(view);
                        });

                    };

                    ngModel.$validators.positiveInteger = function(model, view) { // eslint-disable-line no-unused-vars

                        return testViewValue(view, function(view) {

                            if( isNaN(view) ) {
                                // Ignore the NaN and let that be processed by the 'number' validator above
                                // This is because we display a different error message for that context
                                return true;
                            }
                            else {
                                var parsed = new Number(view);
                                // In this case, we really just want to compare value, not type
                                // eslint-disable-next-line eqeqeq
                                return parsed == parsed.toFixed(0);
                            }

                        });

                    };

                    scope.$watchGroup([
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$viewValue;
                        },
                        function() {
                            var ngOtherModel = getNgOtherModel();
                            return ngOtherModel && ngOtherModel.$modelValue;
                        }
                    ], function() {
                        ngModel.$validate();
                    });

                    var _ngOtherModel;
                    function getNgOtherModel() {
                        if(!_ngOtherModel) {
                            _ngOtherModel = scope.$eval(attrs.emailQuotaType);
                        }
                        return _ngOtherModel;
                    }

                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/validators/emailAccountSafePeriods.js Copyright(c) 2017 cPanel, Inc.
#                                                                                       All rights Reserved.
# copyright@cpanel.net                                                                     http://cpanel.net
# This code is subject to the cPanel license.                             Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/validators/emailAccountSafePeriods',[
        "angular"
    ],
    function(angular) {

        /**
         * Directive that makes sure an input doesn't start or end with a period, or contain two consecutive periods
         *
         * @example
         * <input type="text" name="account" email-safe-periods>
         */

        var module;
        try {
            module = angular.module("cpanel.mail.Pops");
        }
        catch(e) {
            module = angular.module("cpanel.mail.Pops", []);
        }

        module.directive("emailSafePeriods", function () {
            return {
                require: "ngModel",
                restrict: "A",
                link: function ( scope, element, attrs, ngModel ) { // eslint-disable-line no-unused-vars
                    ngModel.$validators.emailSafePeriods = function(model, view) { // eslint-disable-line no-unused-vars
                        if( !ngModel.$isEmpty(view) ) {
                            return view.indexOf(".") !== 0 && view.lastIndexOf(".") !== (view.length - 1) && view.indexOf("..") === -1;
                        }
                        return true;
                    };
                }
            };
        });

    }
);
/*
# base/frontend/manager/mail/pops/views/addEmailAccount.js Copyright(c) 2017 cPanel, Inc.
#                                                                          All rights Reserved.
# copyright@cpanel.net                                                        http://cpanel.net
# This code is subject to the cPanel license.                Unauthorized copying is prohibited
*/

/* global define: false, PAGE: false */

define(
    'app/views/addEmailAccount',[
        "lodash",
        "angular",
        "cjt/util/locale",
        "uiBootstrap",
        "cjt/directives/actionButtonDirective",
        "cjt/directives/passwordFieldDirective",
        "cjt/directives/validateEqualsDirective",
        "cjt/directives/validationContainerDirective",
        "cjt/directives/validationItemDirective",
        "app/validators/emailAccountAllowedChars",
        "app/validators/emailAccountFullLength",
        "app/validators/emailAccountMaxQuota",
        "app/validators/emailAccountMinQuota",
        "app/validators/emailAccountNumericQuota",
        "app/validators/emailAccountSafePeriods"
    ],
    function(_, angular, LOCALE) {

        var app = angular.module("cpanel.mail.Pops");

        app.controller("addEmailAccountCtrl",
            ["$rootScope", "$scope", "emailAccountsService",
                function($rootScope, $scope, emailAccountsService) {

                    $scope.requiredPasswordStrength = PAGE.requiredPasswordStrength;
                    $scope.userDefinedDefaultQuota = PAGE.userDefinedQuotaDefaultValue;
                    $scope.defaultQuota = PAGE.userDefinedQuotaDefaultValue;
                    $scope.maxQuota = PAGE.maxEmailQuota;
                    $scope.mailDomains = _.map(PAGE.mailDomains, _.property("domain"));
                    $scope.creatingAccount = false;
                    $scope.isRTL = PAGE.isRTL;

                    $scope.emailAccount = {
                        account: undefined,
                        domain: $scope.mailDomains.length > 0 ? $scope.mailDomains[0] : undefined,
                        password: undefined,
                        password2: undefined,
                        quota: $scope.defaultQuota,
                        quotaType: PAGE.defaultQuotaSelected,
                        sendWelcome: true
                    };

                    $scope.clearStatus = function() {
                        $scope.status = undefined;
                    };

                    /**
                     * Click handler for the Create Account button, pulls account, password, domain, quota, and sendWelcome
                     * out of the scope and submits them to the addEmailAccount method on the emailAccountsService.
                     */
                    $scope.addEmailAccount = function() {

                        var formOrder = ["add_email_account", "add_email_domain", "add_email_password1", "add_email_password2", "quota"];

                        if( $scope.addEmailAccountForm.$invalid ) {
                            $scope.addEmailAccountForm.$setSubmitted();
                            var focused = false;

                            angular.forEach(formOrder, function(name) {
                                if( $scope.addEmailAccountForm[name] && $scope.addEmailAccountForm[name].$invalid ) {
                                    $scope.addEmailAccountForm[name].$setDirty();
                                    if( !focused ) {
                                        angular.element("[name='addEmailAccountForm'] [name='" + name + "']").focus();
                                        focused = true;
                                    }
                                }
                            });

                            return;
                        }

                        var newAccount = {
                            email: $scope.emailAccount.account,
                            password: $scope.emailAccount.password,
                            domain: $scope.emailAccount.domain,
                            send_welcome_email: $scope.emailAccount.sendWelcome ? 1 : 0,
                            quota: 0
                        };

                        if( $scope.emailAccount.quotaType === "userdefined" ) {
                            newAccount.quota = $scope.emailAccount.quota;
                        }

                        $scope.creatingAccount = true;
                        $scope.status = undefined;

                        return emailAccountsService.addEmailAccount(newAccount).then(
                            function(data) {
                                $scope.creatingAccount = false;

                                var created = data.replace("+", "@");
                                $scope.status = {
                                    type: "success",
                                    message: LOCALE.maketext("Account “[_1]” created.", created),
                                    closeable: true,
                                    autoClose: 10000
                                };

                                $scope.emailAccount = {
                                    account: undefined,
                                    domain: $scope.mailDomains.length > 0 ? $scope.mailDomains[0] : undefined,
                                    quota: $scope.defaultQuota,
                                    quotaType: PAGE.defaultQuotaSelected,
                                    sendWelcome: true
                                };

                                $scope.addEmailAccountForm.$setPristine();
                                $scope.addEmailAccountForm.$setUntouched();

                                $rootScope.$broadcast("emailAccountAdded");
                            },
                            function(error) {
                                $scope.status = {
                                    type: "danger",
                                    message: error
                                };
                                $scope.creatingAccount = false;
                            }
                        );
                    };

                }]
        );

    }
);
/*
# base/frontend/manager/mail/pops/views/configurationOptions.js Copyright(c) 2017 cPanel, Inc.
#                                                                               All rights Reserved.
# copyright@cpanel.net                                                             http://cpanel.net
# This code is subject to the cPanel license.                     Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/views/configurationOptions',[
        "angular",
        "cjt/util/locale"
    ],
    function(angular, LOCALE) {

        var app = angular.module("cpanel.mail.Pops");

        app.controller("configurationOptionsCtrl",
            ["$scope", "growl", "emailAccountsService",
                function($scope, growl, emailAccountsService) {

                    $scope.sharedAddressBook = {
                        enabled: false,
                        enabling: true,
                        disabling: true
                    };

                    $scope.clearStatus = function() {
                        $scope.status = undefined;
                    };

                    /**
                     * Click handler for the "On" button, calls emailAccountsService.enableSharedAddressBook()
                     */
                    $scope.onClickEnableSharedAddressBook = function() {

                        if( $scope.sharedAddressBook.enabled ) {
                            return;
                        }

                        $scope.sharedAddressBook.enabling = true;
                        $scope.status = undefined;

                        emailAccountsService.enableSharedAddressBook().then(
                            function(data) {
                                $scope.status = {
                                    message: LOCALE.maketext("Shared address book enabled."),
                                    type: "success",
                                    closeable: true,
                                    ttl: 10000
                                };
                                $scope.sharedAddressBook.enabled = ("" + data.shared) === "1";
                                $scope.sharedAddressBook.enabling = false;
                            },
                            function(error) {
                                $scope.status = {
                                    message: error,
                                    type: "danger"
                                };
                            }
                        );
                    };

                    /**
                     * Click handler for the "Off" button, calls emailAccountsService.disableSharedAddressBook()
                     */
                    $scope.onClickDisableSharedAddressBook = function() {

                        if( !$scope.sharedAddressBook.enabled ) {
                            return;
                        }

                        $scope.sharedAddressBook.disabling = true;
                        $scope.status = undefined;

                        emailAccountsService.disableSharedAddressBook().then(
                            function(data) {
                                $scope.status = {
                                    message: LOCALE.maketext("Shared address book disabled."),
                                    type: "success",
                                    closeable: true,
                                    ttl: 10000
                                };
                                $scope.sharedAddressBook.enabled = ("" + data.shared) === "1";
                                $scope.sharedAddressBook.disabling = false;
                            },
                            function(error) {
                                $scope.status = {
                                    message: error,
                                    type: "danger"
                                };
                            }
                        );
                    };

                    emailAccountsService.isSharedAddressBookEnabled().then(
                        function(data) {
                            $scope.sharedAddressBook.enabled = ("" + data.shared) === "1";
                            $scope.sharedAddressBook.enabling = false;
                            $scope.sharedAddressBook.disabling = false;
                        },
                        function(error) {
                            $scope.sharedAddressBook.enabling = false;
                            $scope.sharedAddressBook.disabling = false;
                            growl.error(error);
                        }
                    );

                }]
        );
    }
);
/*
# base/frontend/manager/mail/pops/views/defaultAccount.js Copyright(c) 2017 cPanel, Inc.
#                                                                         All rights Reserved.
# copyright@cpanel.net                                                       http://cpanel.net
# This code is subject to the cPanel license.               Unauthorized copying is prohibited
*/

/* global define: false */

define(
    'app/views/defaultAccount',[
        "angular",
    ],
    function(angular) {

        var app = angular.module("cpanel.mail.Pops");

        app.controller("defaultAccountCtrl",
            ["$scope", "growl", "emailAccountsService",
                function($scope, growl, emailAccountsService) {
                    emailAccountsService.getDefaultAccountUsage().then(
                        function(data) {
                            $scope.defaultAccountDiskUsed = data;
                        },
                        function(error) {
                            growl.error(error);
                        }
                    );
                }]
        );

    }
);
/*
* mail/pops/index.js                              Copyright(c) 2017 cPanel, Inc.
*                                                           All rights Reserved.
* copyright@cpanel.net                                         http://cpanel.net
* This code is subject to the cPanel license. Unauthorized copying is prohibited
*/

/* global require: false, define: false, PAGE: false */

define(
    'app/index',[
        "angular",
        "cjt/modules",
        "jquery-chosen",
        "angular-chosen"
        // "ngRoute"
    ],
    function(angular) {
        return function() {
            // First create the application
            angular.module("cpanel.mail.Pops", [
                "angular-growl",
                "cjt2.cpanel",
                "cjt2.services.api",
                "cjt2.views.applicationController",
                "ngAnimate",
                "localytics.directives"
            ]);

            // Then load the application dependencies
            var app = require([
                "cjt/bootstrap",
                "app/services/emailAccountsService",
                "app/filters/emailLocaleString",
                "app/filters/encodeURIComponent",
                "app/filters/incomingSuspendedTooltip",
                "app/filters/landingPageHref",
                "app/filters/loginIncomingHref",
                "app/filters/loginIncomingText",
                "app/filters/loginIncomingTooltip",
                "app/filters/loginSuspendedTooltip",
                "app/filters/quotaProgressType",
                "app/views/listEmailAccounts",
                "app/views/addEmailAccount",
                "app/views/configurationOptions",
                "app/views/defaultAccount"
            ], function(BOOTSTRAP) {

                var app = angular.module("cpanel.mail.Pops");

                app.config(["$animateProvider", function($animateProvider) {
                    $animateProvider.classNameFilter(/(action-module|disappearing-table-row)/);
                }]);

                // TODO: Refactor into tabs and update Selenium tests
                // app.config(["$routeProvider",
                //     function($routeProvider) {

                //         if( !window.PAGE.accountsAreMaxed ) {
                //             $routeProvider.when("/addEmailAccount", {
                //                 controller: "addEmailAccountCtrl",
                //                 templateUrl: CJT.buildFullPath("mail/pops/views/addEmailAccount.ptt")
                //             });
                //         }

                //         $routeProvider.when("/listEmailAccounts", {
                //             controller: "listEmailAccountsCtrl",
                //             templateUrl: CJT.buildFullPath("mail/pops/views/listEmailAccounts.ptt")
                //         });

                //         if( window.PAGE.defaultAccountEnabled ) {
                //             $routeProvider.when("/defaultAccount", {
                //                 controller: "defaultAccountCtrl",
                //                 templateUrl: CJT.buildFullPath("mail/pops/views/defaultAccount.ptt")
                //             });
                //         }

                //         if( window.PAGE.showConfigSection ) {
                //             $routeProvider.when("/configurationOptions", {
                //                 controller: "configurationOptionsCtrl",
                //                 templateUrl: CJT.buildFullPath("mail/pops/views/configurationOptions.ptt")
                //             });
                //         }

                //     }
                // ]);

                // var tabs = {
                //     "/addEmailAccount": 0,
                //     "/listEmailAccounts": 1,
                //     "/defaultAccount": 2,
                //     "/configurationOptions": 3
                // };

                app.controller("baseController",
                    ["$scope",
                        function($scope) {

                            $scope.pageTabs = [];
                            $scope.loading = true;
                            $scope.activeTab = -1;
                            $scope.mailAccountsCount = PAGE.mailAccountsCount;
                            $scope.showAddAccount = !window.PAGE.accountsAreMaxed;
                            $scope.showDefaultAccount = window.PAGE.defaultAccountEnabled;
                            $scope.showConfigSection = window.PAGE.showConfigSection;

                            // TODO: Refactor into tabs and update Selenium tests
                            // $rootScope.$on("$routeChangeStart", function() {
                            //     $scope.loading = true;
                            // });

                            // $rootScope.$on("$routeChangeSuccess", function() {
                            //     $scope.loading = false;
                            //     $scope.activeTab = tabs[$location.path()];
                            // });

                            // $rootScope.$on("$routeChangeError", function() {
                            //     $scope.loading = false;
                            // });

                            // $scope.go = function(path) {

                            //     if( path === "" ) {
                            //         path = $scope.mailAccountsCount == 0 && $scope.showAddAccount ? "/addEmailAccount" : "/listEmailAccounts";
                            //     }

                            //     $location.path(path);
                            //     $scope.activeTab = tabs[path];
                            // }

                            // $scope.go($location.path());
                        }]
                );

                app.animation(".action-module", ["$animateCss", function($animateCss) {
                    return {
                        enter: function(elem, done) {
                            var height = elem[0].offsetHeight;
                            return $animateCss(elem, {
                                from: { height: "0" },
                                to: { height: height + "px" },
                                duration: 0.3,
                                easing: "ease-out",
                                event: "enter",
                                structural: true
                            })
                                .start()
                                .done(function() {
                                    elem[0].style.height = "";
                                    done();
                                });
                        },
                        leave: function(elem, done) {
                            var height = elem[0].offsetHeight;
                            return $animateCss(elem, {
                                event: "leave",
                                structural: true,
                                from: { height: height + "px" },
                                to: { height: "0" },
                                duration: 0.3,
                                easing: "ease-out",
                            })
                                .start()
                                .done(function() {
                                    done();
                                });
                        },
                    };
                }]);

                BOOTSTRAP("#body-content", "cpanel.mail.Pops");
            });

            return app;
        };
    }
);

