define(["angular","lodash","cjt/util/locale","uiBootstrap","cjt/directives/alertList","cjt/services/alertService","cjt/decorators/paginationDecorator","cjt/directives/toggleSortDirective","cjt/directives/validationItemDirective","cjt/directives/spinnerDirective","cjt/directives/autoFocus","cjt/filters/wrapFilter","cjt/filters/breakFilter","app/services/modSecurityDomainService"],function(angular,_,LOCALE){var app=angular.module("App");var _updateStatus=function(list,updates){for(var i=0,l=list.length;i<l;i++){var update=_findUpdateByDomain(updates,list[i].domain);if(update){list[i].enabled=update.enabled;if(update.exception){list[i].exception=update.exception}else{delete list[i].exception}}else{if(list[i].exception){delete list[i].exception}}}};var _findUpdateByDomain=function(updates,domain){for(var i=0,l=updates.length;i<l;i++){if(updates[i].domain===domain){return updates[i]}}return};var _mergeIssue=function(domain,issue){if(issue){if(issue.exception){domain.exception=issue.exception}else{if(domain.exception){delete domain.exception}}}};var _findIndexOf=function(array,predicate){for(var i=0,l=array.length;i<l;++i){if(predicate(array[i])){return i}}return-1};var _findIndexOfIssueByDomain=function(issues,domain){return _findIndexOf(issues,function(issue){return domain===issue.domain})};var _removeIssueByDomain=function(issues,domain){if(issues&&issues.length>0){var index=_findIndexOfIssueByDomain(issues,domain);if(index!==-1){issues.splice(index,1)}}};var _addIssueByDomain=function(issues,domain,exception){var index=_findIndexOfIssueByDomain(issues,domain);var issue={domain:domain,exception:exception};if(index!==-1){issues.splice(index,1,issue)}else{issues.push(issue)}};var _mergeIssues=function(domains,issues){if(!issues||issues.length===0){return domains}else{angular.forEach(domains,function(domain){var relatedIssue=_.find(issues,function(issue){return domain.domain===issue.domain});_mergeIssue(domain,relatedIssue)})}return domains};var controller=app.controller("domainListController",["$scope","$routeParams","$q","modSecurityDomainService","spinnerAPI","alertService",function($scope,$routeParams,$q,modSecurityDomainService,spinnerAPI,alertService){var _initializeScope=function(){$scope.activeSearch=false;$scope.filteredData=false;$scope.totalEnabled=0;$scope.totalDisabled=0;$scope.selectedRow=-1;$scope.alerts=alertService.getAlerts();$scope.hasIssues=false;$scope.issues=[];$scope.openConfirmation=null;$scope.isInstalled=PAGE.installed;$scope.hasFeature=PAGE.hasFeature;if(!$scope.hasFeature){return}$scope.domainList=[];$scope.totalPages=0;$scope.totalItems=0;$scope.meta={filterBy:$routeParams.filterBy||"*",filterCompare:$routeParams.filterCompare||"contains",filterValue:$routeParams.filterValue||"",pageSize:$routeParams.pageSize||10,pageNumber:$routeParams.pageNumber||1,sortDirection:$routeParams.sortDirection||"asc",sortBy:$routeParams.sortBy||"domain",sortType:$routeParams.sortType,pageSizes:[10,20,50,100]}};$scope.clearFilter=function(){$scope.meta.filterValue="";$scope.activeSearch=false;$scope.filteredData=false;$scope.selectedRow=-1;return $scope.fetch()};$scope.startFilter=function(){$scope.activeSearch=true;$scope.filteredData=false;$scope.selectedRow=-1;var defer=$q.defer();defer.promise.then(function(){$scope.selectPage(1)}).then(function(){$scope.filteredData=true});defer.resolve()};$scope.toggleRow=function($event,index){$event.preventDefault();if(index===$scope.selectedRow){$scope.selectedRow=-1}else{$scope.selectedRow=index}};$scope.selectPage=function(page){$scope.selectedRow=-1;if(page&&angular.isNumber(page)){$scope.meta.pageNumber=page}return $scope.fetch()};$scope.sortList=function(meta,defaultSort){$scope.selectedRow=-1;if(!defaultSort){$scope.fetch()}};$scope.triggerToggleSearch=function(event){if(event.keyCode===27){$scope.toggleSearch(true)}if(event.keyCode===13){$scope.toggleSearch()}};$scope.toggleSearch=function(isClick){var filter=$scope.meta.filterValue;if(!filter&&($scope.activeSearch||$scope.filteredData)){$scope.clearFilter()}else if(isClick&&$scope.activeSearch){$scope.clearFilter()}else if(filter){$scope.startFilter()}};$scope.fetch=function(){spinnerAPI.start("loadingSpinner");return modSecurityDomainService.fetchList($scope.meta).then(function(results){$scope.domainList=_mergeIssues(results.items,$scope.issues);$scope.totalItems=results.totalItems;$scope.totalPages=results.totalPages;$scope.totalEnabled=results.totalEnabled;$scope.totalDisabled=results.totalDisabled},function(error){alertService.add({type:"danger",message:error,id:"fetchError"})}).then(function(){spinnerAPI.stop("loadingSpinner")})};$scope.setDomain=function(domain){spinnerAPI.start("loadingSpinner");if(domain.enabled){return modSecurityDomainService.enableDomains(domain.domain).then(function(result){$scope.totalEnabled++;$scope.totalDisabled--;_removeIssueByDomain($scope.issues,domain.domain);if(domain.exception){delete domain.exception}_updateIssuesFlag();alertService.add({type:"success",message:LOCALE.maketext("Successfully enabled [asis,ModSecurity™] on “[_1]”.",result.items[0].domain),id:"enableSuccess"})},function(results){var error;if(!angular.isString(results)){var exception=results.items[0].exception;var enabled=results.items[0].enabled;_addIssueByDomain($scope.issues,domain.domain,exception);domain.exception=exception;domain.enabled=enabled;_updateIssuesFlag();error=results.error}else{error=results}alertService.add({type:"danger",message:error,id:"enableFailure"})}).then(function(){spinnerAPI.stop("loadingSpinner")})}else{return modSecurityDomainService.disableDomains(domain.domain).then(function(result){$scope.totalDisabled++;$scope.totalEnabled--;_removeIssueByDomain($scope.issues,domain.domain);if(domain.exception){delete domain.exception}_updateIssuesFlag();alertService.add({type:"success",message:LOCALE.maketext("Successfully disabled [asis,ModSecurity™] on “[_1]”.",result.items[0].domain),id:"disableSuccess"})},function(results){var error;if(!angular.isString(results)){var exception=results.items[0].exception;var enabled=results.items[0].enabled;_addIssueByDomain($scope.issues,domain.domain,exception);domain.exception=exception;domain.enabled=enabled;_updateIssuesFlag();error=results.error}else{error=results}alertService.add({type:"danger",message:error,id:"disableFailed"})}).then(function(){spinnerAPI.stop("loadingSpinner")})}};$scope.enableAllDomains=function($event){$event.preventDefault();spinnerAPI.start("loadingSpinner");return modSecurityDomainService.enableAllDomains().then(function(results){_clearIssues();_updateStatus($scope.domainList,results.items);$scope.totalItems=results.totalItems;$scope.totalPages=results.totalPages;$scope.totalEnabled=results.totalItems;$scope.totalDisabled=0;alertService.add({type:"success",message:LOCALE.maketext("Successfully enabled [asis,ModSecurity™] on all domains."),id:"enableAllSuccess"})},function(results){var error;if(!angular.isString(results)){_updateStatus($scope.domainList,results.items);$scope.issues=results.items||[];_updateIssuesFlag();$scope.totalEnabled=results.totalEnabled;$scope.totalDisabled=results.totalDisabled;error=results.error}else{error=results}alertService.add({type:"danger",message:error,id:"enableAllFailed"})}).then(function(){spinnerAPI.stop("loadingSpinner")})};$scope.disableAllDomains=function($event){$event.preventDefault();spinnerAPI.start("loadingSpinner");return modSecurityDomainService.disableAllDomains().then(function(results){_updateStatus($scope.domainList,results.items);$scope.issues=results.items||[];$scope.totalItems=results.totalItems;$scope.totalPages=results.totalPages;$scope.totalDisabled=results.totalItems;$scope.totalEnabled=0;alertService.add({type:"success",message:LOCALE.maketext("Successfully disabled [asis,ModSecurity™] on all domains."),id:"disableAllSuccess"})},function(results){var error;if(!angular.isString(results)){_updateStatus($scope.domainList,results.items);$scope.issues=results.items||[];_updateIssuesFlag();$scope.totalEnabled=results.totalEnabled;$scope.totalDisabled=results.totalDisabled;error=results.error}else{error=results}alertService.add({type:"danger",message:error,id:"disableAllFailed"})}).finally(function(){spinnerAPI.stop("loadingSpinner");$scope.openConfirmation=null})};var _updateIssuesFlag=function(){var match=_.find($scope.domainList,function(domain){return!!domain.exception});$scope.hasIssues=typeof match!=="undefined"};$scope.hasIssue=function(domain){return!!domain.exception};var _clearIssues=function(){delete $scope.hasIssues};$scope.hasDisabledDomains=function(){return $scope.totalDisabled>0};$scope.confirm=function(confirmation){$scope.openConfirmation=confirmation?confirmation:null};var _initializeView=function(){if(app.firstLoad.domainList&&PAGE.domainList){app.firstLoad.domainList=false;var results=modSecurityDomainService.prepareList(PAGE.domainList);$scope.meta.pageNumber=1;$scope.domainList=results.items;$scope.totalItems=results.totalItems;$scope.totalPages=results.totalPages;$scope.totalEnabled=PAGE.domainList.meta.modsec.total_enabled;$scope.totalDisabled=PAGE.domainList.meta.modsec.total_disabled}else{$scope.selectPage(1)}};_initializeScope();$scope.$watch("meta.filterValue",function(oldValue,newValue){if(oldValue===newValue){return}$scope.activeSearch=false});$scope.$watch("meta.pageSize",function(oldValue,newValue){if(oldValue===newValue){return}$scope.selectPage(1)});_initializeView()}]);return controller});